﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

'Activity module
Sub Process_Globals
' curve variables
	Dim CurveNb As Int			: CurveNb = 100		' max Number of curves
	Dim CurveNbC As Int			: CurveNbC = 14		' Number of calculated curves
	Dim CurveI As Int				: CurveI = 2			' index of displayed curve 

	Dim CurveSampleNbMax As Int	: CurveSampleNbMax = 5000
	Dim CurveSampleNb As Int		: CurveSampleNb = 720	' total Number of samples for curves
	Dim Curve(CurveNb + 1, CurveSampleNbMax + 1) As Double		' values of curves
	Dim CurveName(CurveNb + 1) As String							' curve name
	Dim CurveUnit(CurveNb + 1) As String							' curve unit
	Dim CurveTime(CurveNb + 1) As Double			' curve time interval
	Dim CurveDeg(CurveNb + 1) As Double				' curve degree interval
	Dim CurveSpd(CurveNb + 1) As Double				' curve speed
	Dim CurveSpdUnit(CurveNb + 1) As String		' curve speed unit
	Dim CurveMax(CurveNb + 1)	As Double				' curve max value
	Dim CurveMin(CurveNb + 1)	As Double				' curve min value
	Dim CurveMaxMin(CurveNb + 1) As Double		' curve max value - min value
	Dim CurveComm(CurveNb + 1) As String			' curve commentary
	Dim CurveCommText(CurveNb + 1) As String	' curve commentary additional text
	Dim CurveCol(CurveNb + 1) As Int					' curve color
	Dim ColCurve(4) As Int										' curve color
	Dim WidthCurve(4) As Float								' curve width
		
	Dim CurveScMaxA(CurveNb + 1) As Double		' curve scale max  automatic
	Dim CurveScMinA(CurveNb + 1) As Double		' curve scale min  automatic
	Dim CurveScDA(CurveNb + 1) As Double			' curve scale tick automatic
	Dim CurveScMaxM(CurveNb + 1) As Double		' curve scale max  manual
	Dim CurveScMinM(CurveNb + 1) As Double		' curve scale min  manual
	Dim CurveScDM(CurveNb + 1) As Double			' curve scale tick manual
	Dim CurveDispNumbers As Boolean		: CurveDispNumbers = True			' curves display  Doubles
	Dim CurveDispUnits As Boolean 		: CurveDispUnits = True				' curves display  units
	Dim CurveDispSpeed As Boolean 		: CurveDispSpeed = True				' curves display  speed
	Dim CurveDispSpeedUnit As Boolean	: CurveDispSpeedUnit = True		' curves display  speed unit
	Dim CurveDispComm As Boolean			: CurveDispComm = True				' curves display  commentary
	Dim CurveDispCommText As Boolean	: CurveDispCommText = False		' curves display  commentary text
	Dim CurveCommKp As Boolean				: CurveCommKp = True					' curves comment add Kp
	Dim CurveCommKs As Boolean				: CurveCommKs = True					' curves comment add Kv
	Dim CurveCommKa As Boolean				: CurveCommKa = True					' curves comment add Ka
	Dim CurveCommKj As Boolean				: CurveCommKj = False					' curves comment add Kj
	Dim CurveCommTp As Boolean				: CurveCommTp = False					' curves comment add Tp
	Dim CurveCommTs As Boolean				: CurveCommTs = False					' curves comment add Ts
	Dim CurveCommDd As Boolean				: CurveCommDd = False					' curves comment add Dd
	Dim CurveCommTd As Boolean				: CurveCommTd = False					' curves comment add Td
	Dim CurveCommText0 As String			: CurveCommText0 = ""					' curves comment text
	
	Dim CurveStep As Int							: CurveStep = 1
	
' graphic superposition variables
	Dim SupNb As Int				: SupNb = 10		' Number of curve superpositions
	Dim SupI As Int					: SupI = -1			' superposition index 
			
	Dim SupIN(SupNb) As Int									' Number of curves in each superposition
	Dim SupIJ(SupNb, 4) As Int							' indexes of curves in the superpositions
	
' graphic cursor variables
	Dim CursFlag As Int			: CursFlag = 0	' flag cursor inactive = 0    active = 1
	Dim CursI As Int				: CursI = -1		' position of cursor in pixels

	Dim NJ0 As Int		: NJ0 = 0				' new index of first sample
	Dim NJ0p As Int		: NJ0p = 0
	Dim NJ1p As Int		: NJ1p = 0

' time frequency conversion variables
	Dim Tfc(2) As Double				' curve indexes of cursor position
	Dim Tfcp(2) As Double				' cursor positions in pixels
	Dim FlagTimeFreq As Double	: FlagTimeFreq = 0		' flag for time to frequency conversion
	Dim Tfci As Double					: Tfci = 0						' flag for cursor Number 0 or 1

	Dim GX0 As Int			: GX0 = 0			' left of graphic area
	Dim GY0 As Int			: GY0 = 0			' top of graphic area
	Dim GW As Int				: GW = 0			' current graphic area width
	Dim GH As Int				: GH = 0			' graphic area heigh
	Dim GX1 As Int			: GX1 = 0			' right of current graphic area
	Dim GY1 As Int			: GY1 = 0			' bottom of graphic area
	Dim GdX As Int			: GdX = 0			' width of graphic grid
	
	Dim J0 As Int			: J0 = 0					' index of first sample of zoom calculation
	Dim J1 As Int			: J1 = 360				' index of last sample of zoom calculation
	Dim J0C As Int		: J0C = 0					' index of first sample of zoom curves
	Dim J1C As Int		: J1C = 360				' index of last sample of zoom curves
	Dim Jw As Int			: Jw = J1 - J0		' width of zoomed samples
	Dim JwC As Int		: JwC = J1C - J0C	' width of zoomed curve samples
	Dim JdC As Int		: JdC = JwC / 2		' width of zoom scroll steps
	Dim Jj As Int			: Jj = 0					' index of curves for calculation saving		
	Dim J0z As Int		: J0z = 0					' index of first zoom sample
	Dim J1z As Int		: J1z = 0					' index of last zoom sample

	Dim CurveAbscissaType As Int		: CurveAbscissaType = 1		' 0 = time
																														' 1 = degrees
																														' 2 = indices
' scale varaibles
	Dim ScMin As Double				: ScMin = 0				' scale min
	Dim ScMax As Double				: ScMax = 1				' scale max
	Dim ScX As Double					: ScX = 0					' X scale
	Dim ScY As Double					: ScY = 1					' Y scale
	Dim ScLog As Double				: ScLog = 0				' scale logarythm
	Dim ScExp As Double				: ScExp = 0				' exponant of scale logarythm
	Dim ScMant As Double			: ScMant = 0			' mantissa of scale logarythm
	Dim ScYNb As Int					: ScYNb = 10			' nb. of Y divisions
	Dim ScXNb As Int					: ScXNb = 18			' nb. of X divisions
	Dim ScNb As Int						: ScNb = 0				' nb. of X divisions
	Dim ScNbDiv As Int				: ScNbDiv = 0			' nb. of current X divisions
	Dim ScNbDivOcc As Int			: ScNbDivOcc = 0	' nb. ofoccupied X divisions
	Dim ScaleMan As Int				: ScaleMan = 0		'  = 0 scale Automatic

	Dim ScBeginGrid  As Int							: ScBeginGrid = 0		' beginning of X grid
	Dim flagZoom  As Int								: flagZoom = 0
	Dim DrawBitmap  As Int							: DrawBitmap = 0						' flag = 1 for drawing the bitmap for copying
	Dim DrawBitmapFrame As Boolean			:	DrawBitmapFrame = True		' flag for drawing frame on bitmap
	Dim DrawBitmapColor As Int					: DrawBitmapColor = Colors.White	'bitmap backcolor
	Dim DrawBitmapPreview As Boolean 		: DrawBitmapPreview = True
		
	Dim DrawGridSize0(3) As Double
		DrawGridSize0(0) = 38			' 10 mm
		DrawGridSize0(1) = 30			'  8 mm
		DrawGridSize0(2) = 19			'  5 mm
	Dim DrawGridSizeI As Int					: DrawGridSizeI = 0
	Dim DrawGridSize As Double				: DrawGridSize = DrawGridSize0(DrawGridSizeI)

	Dim Zoomed As Boolean				: Zoomed = False
	Dim ZoomMode As Double			: ZoomMode = 0

' Graph copy variables
	Dim GC_CurveNb As Int					: GC_CurveNb = 0
	Dim GC_CurveI(CurveNb) As Int
	Dim GC_CopyI As Int						: GC_CopyI = 0

' Graph calculation variables
	Dim FlagGraphCalc As Int			: FlagGraphCalc = 0			' calculation type
	Dim cOffset As Int					: cOffset = 0
	Dim cGain As Int						: cGain = 1
	
	Dim ZJ0, ZJ1, ZW, Zd, ZJMax As Int	'used for zoom scrolling
	Dim flagZoomScroll = 0 As Int
End Sub

Sub Globals
	Dim pnlToolBox, pnlToolboxCurveCalc, pnlToolBoxScales, pnlSelection As Panel
	Dim pnlGrid, pnlGraph, pnlCursor As Panel
	Dim btnScales, btnScaleAuto, btnScaleManuel, btnScaleChange, btnBack As Panel
	Dim btnCurveUp, btnCurveDown, btnSuperposUp, btnSuperposDown As Panel
	Dim cvsGrid, cvsGraph, cvsCursor, cvsBmpGraph As Canvas
	Dim rectScreen, rectGrid, rectCursor, rectCurveValues, rectAbscissaValues As Rect
	Dim rectZoom0, rectZoom1 As Rect
	Dim bmpGaph As Bitmap
	Dim lblToolTip As Label
	Dim cbbCurves, cbbSuperpos As ComboBox
	Dim edtCurveStep As EditText
	
	Dim btnCalc, btnZoom, btnUnZoom, btnHelp As Panel
	Dim btnCalcDerivative, btnCalcDifference,btnCalcDivision, btnCalcIntegral, btnCalcDerivative As Panel
	Dim btnCalcMean, btnCalcProduct, btnCalcSum, btnConvertTimeFreq, btnCurveGain, btnCurveOffset  As Panel
	Dim btnLoadCurves, btnSaveCurves, btnConfigGraph, btnEditCurveValues As Panel
	Dim btnSuperposCurves, btnCopyCurves As Panel
	Dim pnlZoom, pnlZoomScroll As Panel
	Dim cvsZoomScroll As Canvas
	Dim rectZoomScroll,rectZoomCursor As Rect
	Dim edtZoomJ0, edtZoomJ1, edtZoomJW, edtZoomJD, edtDummy As EditText

	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If FirstTime = True Then
		Activity_Init
	End If
	
	Activity.LoadLayout("graph")
	
	rectScreen.Initialize(0, 0, 100%x, 100%y)
	
	bmpGaph.InitializeMutable(100dip, 80dip)
	
	cvsGrid.Initialize(pnlGrid)
	cvsGraph.Initialize(pnlGraph)
	cvsCursor.Initialize(pnlCursor)
	cvsBmpGraph.Initialize2(bmpGaph)
	cvsZoomScroll.Initialize(pnlZoomScroll)
	
	Dim bdw As BitmapDrawable
	If ScaleMan = 0 Then
		bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleAuto0.png"))
	Else
		bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleManuel0.png"))
	End If
	btnScales.Background = bdw
	
	cbbCurves.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbCurves.NumberVisibleItems = 15
	cbbCurves.FastScrollEnabled = True
	cbbSuperpos.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbSuperpos.NumberVisibleItems = 10
	
	cbbCurves.ItemColor = Colors.RGB(255, 228, 181)
	cbbCurves.ItemTextColor = Colors.Black
	cbbSuperpos.ItemColor = Colors.RGB(255, 228, 181)
	cbbSuperpos.ItemTextColor = Colors.Black
	
	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)
	IME1.Initialize("")
	rectZoomCursor.Initialize(0, 0, 10dip, 4dip)
End Sub

Sub Activity_Resume
	Calc.InitCurveComboBox(cbbCurves)
	cbbCurves.SelectedIndex = CurveI - 1
	Calc.InitSuperposComboBox(cbbSuperpos)
	cbbSuperpos.SelectedIndex = SupI
	
	DrawInit
	
	If ScaleChange.ScaleChange = True Then
		btnScaleManuelDo
		btnScales_Touch(1, 1, 1)
		ScaleChange.ScaleChange = False
	End If
	DrawCurves(SupI)
	edtCurveStep.Text = CurveStep
	
	If J0C > 0 OR J1C < CurveSampleNb Then
		ZoomInit
		Zoomed = True
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_Init
	SupNb = 10
	SupI = 4
	SupIN(0) = 2
	SupIJ(0,0) = 1
	SupIJ(0,1) = 2

	SupIN(1) = 2
	SupIJ(1,0) = 3
	SupIJ(1,1) = 4

	SupIN(2) = 3
	SupIJ(2,0) = 1
	SupIJ(2,1) = 2
	SupIJ(2,2) = 3

	SupIN(3) = 4
	SupIJ(3,0) = 2
	SupIJ(3,1) = 8
	SupIJ(3,2) = 9
	SupIJ(3,3) = 10
	
	SupIN(4) = 3
	SupIJ(4,0) = 2
	SupIJ(4,1) = 8
	SupIJ(4,2) = 11

	SupIN(6) = 3
	SupIJ(6,0) = 3
	SupIJ(6,1) = 9
	SupIJ(6,2) = 12

	ColCurve(0) = Colors.Red
	ColCurve(1) = Colors.Blue
	ColCurve(2) = Colors.RGB(0, 140, 30)
	ColCurve(3) = Colors.Magenta
	
	WidthCurve(0) = 2dip
	WidthCurve(1) = 2dip
	WidthCurve(2) = 2dip
	WidthCurve(3) = 2dip
End Sub

Sub DrawGrid
	Dim I, x0, x1, y0, y1 As Int
	
	If DrawBitmap=0 Then
		cvsGrid.DrawRect(rectScreen, Colors.White, True , 1)
	Else
		cvsBmpGraph.DrawRect(rectScreen, DrawBitmapColor, True , 1)
	End If
	
	y0 = GY0
	y1 = GY1

	For I = 0 To ScNb
		x0 = GX0 + GdX * I + ScBeginGrid
		If x0 >= GX1 Then Exit
		cvsGrid.DrawLine(x0, y0, x0, y1, Colors.RGB(230,230,230), 1)
	Next
	x0 = GX0
	x1 = GX1
	For I = 0 To ScYNb
		y0 = GY0 + GdX * I
		cvsGrid.DrawLine(x0, y0, x1, y0, Colors.RGB(230,230,230), 1)
	Next
	
	cvsGrid.DrawRect(rectGrid, Colors.Black, False, 1dip)
	
	DrawAbscissa
	pnlGrid.Invalidate
	
End Sub

Sub DrawAbscissa
	Dim i, l1 As Int
	Dim x, y As Int
	Dim fts As Float
	Dim v, l As Double
	Dim v1 As String
	
	fts = 14
	y = GY1 + 15dip
	
	
	l = Logarithm(CurveScDA(0), 10)
	l1 = Ceil(-l)
	For i = 0 To ScNbDiv Step 2
		v = i * CurveScDA(0) + ScMin
		If CurveAbscissaType = 1 Then
			v = v Mod 360
		End If
		If v < 1e-12 Then
			v = 0
		End If
		x = GX0 + i * GdX + ScBeginGrid
		
		If x  > GX1 Then Return
		
		If l > 0 Then
			v1 = NumberFormat2(v, 1, 0, 0, False)
		Else	
			v1 = NumberFormat2(v, 1, l1, 0, False)
		End If
		
		If DrawBitmap = 0 Then
			cvsGrid.DrawText(v1, x, y, Typeface.DEFAULT, fts, Colors.Black, "CENTER")
		Else
			cvsBmpGraph.DrawText(v1, x, y, Typeface.DEFAULT, fts, Colors.Black, "CENTER")
		End If
	Next
	
	y = y + 2dip
	Select CurveAbscissaType
	Case 0
		If DrawBitmap=0 Then
			cvsGrid.DrawText("s", GX1 + 20dip, y, Typeface.DEFAULT, fts, Colors.Black, "LEFT")
		Else
			cvsBmpGraph.DrawText("s", GX1 + 20dip, y, Typeface.DEFAULT, fts, Colors.Black, "LEFT")
		End If
	Case 1
		If DrawBitmap=0 Then
			cvsGrid.DrawText("deg", GX1 + 20dip, y, Typeface.DEFAULT, fts, Colors.Black, "LEFT")
		Else
			cvsBmpGraph.DrawText("deg", GX1 + 20dip, y, Typeface.DEFAULT, fts, Colors.Black, "LEFT")
		End If
	Case 2
		If DrawBitmap=0 Then
			cvsGrid.DrawText("index", GX1 + 20dip, y, Typeface.DEFAULT, fts, Colors.Black, "LEFT")
		Else
			cvsBmpGraph.DrawText("index", GX1 + 20dip, y, Typeface.DEFAULT, fts, Colors.Black, "LEFT")
		End If
	End Select
End Sub

Sub DrawInit
	GX0 = 100dip
	GY0 = 72dip

	If DrawBitmap = 0 Then
		ScXNb = 18
		ScYNb = 10
		GdX = Min(Floor((pnlGrid.Width - 2 * GX0) / ScXNb), Floor((pnlGrid.Height - GY0 - 40dip) / ScYNb))
	Else
		GdX = DrawGridSize
		ScXNb = 18
		ScYNb = 10
	End If
	
	GX0 = (pnlGrid.Width - GdX * ScXNb) / 2
	GW = GdX * ScXNb 
	GH = GdX * ScYNb
	GX1 = GX0 + GW
	GY1 = GY0 + GH
	
	pnlZoomScroll.Left = GX0
	pnlZoomScroll.Width = GW
	cvsZoomScroll.Initialize(pnlZoomScroll)
	rectZoomScroll.Initialize(0, 0, pnlZoomScroll.Width, pnlZoomScroll.Height)
	cvsZoomScroll.DrawColor(Colors.ARGB(20, 128, 128, 128))
End Sub

Sub DrawCheckSameAbscissa(Mode As Int) As Int		
	Dim I, j, k, l, st, sd As Int
	
	st=0
	sd=0
	For I = 0 To SupIN(SupI) - 2
		k = SupIJ(SupI, I)
		For j = I + 1 To SupIN(SupI) - 1
			l = SupIJ(SupI, j)
			If CurveTime(k) <> CurveTime(l) Then
				st = 1
			End If
			If CurveDeg(k) <> CurveDeg(l) Then
				sd = 1
			End If
		Next 
	Next 
	
	'?????????????
	If Mode = 0 Then
		Select CurveAbscissaType
		Case 0
			If st = 1 Then	
				Return 1
			End If
		Case 1
			If sd = 1 Then	
				Return 1
			End If
		End Select
		Return 0
	Else
		If st = 1 Then	
		End If
		If sd = 1 Then	
		End If
		Return 0
	End If
End Sub

Sub DrawInitAbscissa As Int
	Dim i, answ As Int
	Dim k As Double
	
	If SupI > -1 Then
		answ = DrawCheckSameAbscissa(0)
		If answ = 1 Then
			Return 1
		End If
	End If

	Select CurveAbscissaType
	Case 0
		k = Main.TdtC
	Case 1
		k = Main.TddC
	Case 2
		k = 1
	End Select
	
	For i = 0 To CurveSampleNb
		Curve(0, i) = i * k
	Next 
	
	Return 0
End Sub

Sub ZoomInit
	JwC = J1C - J0C
	JdC = JwC/2
	pnlZoom.Visible = True
	edtZoomJ0.Text = J0C
	edtZoomJ1.Text = J1C
	edtZoomJW.Text = JwC
	edtZoomJD.Text = JdC
	cvsZoomScroll.DrawRect(rectZoomScroll, Colors.Transparent, True, 1)
	cvsZoomScroll.DrawLine(0, pnlZoomScroll.Height - 2dip, pnlZoomScroll.Width, pnlZoomScroll.Height - 2dip, Colors.Blue, 4dip)
	pnlZoomScroll.Invalidate2(rectZoomCursor)
	
	ZJ0 = J0C / CurveSampleNb * pnlZoomScroll.Width
	ZJ1 = J1C / CurveSampleNb * pnlZoomScroll.Width
	ZW = JwC / CurveSampleNb * pnlZoomScroll.Width
	ZJMax = (CurveSampleNb - JwC) / CurveSampleNb * pnlZoomScroll.Width
	rectZoomCursor.Initialize(ZJ0, pnlZoomScroll.Height - 16dip, ZJ1, pnlZoomScroll.Height - 4dip)
	cvsZoomScroll.DrawRect(rectZoomCursor, Colors.Blue, True, 1)
	pnlZoomScroll.Invalidate2(rectZoomCursor)
	
	DrawZoom
End Sub

Sub DrawZoom
	DrawInitAbscissa
'	DrawInitZoomScrollBar
	DrawCurves(SupI)
End Sub

Sub DrawInitZoomScrollBar
	If J0C > 0 OR J1C < CurveSampleNb Then
		If ZoomMode = 0 Then
			ZoomMode = 0
		End If
		ZoomMode = 0
	Else
	End If
End Sub

Sub DrawCurves(In As Int)
	Dim I, n, k, answ As Int
		
	SupI = In
	
	rectGrid.Initialize(GX0, GY0, GX1, GY1)
	cvsGraph.DrawRect(rectScreen, Colors.Transparent, True, 1)
	cvsCursor.DrawRect(rectScreen, Colors.Transparent, True, 1)

	answ = DrawInitAbscissa
	If answ = 1 Then
		Return
	End If
	DrawCalcScaleX
	DrawGrid
	DrawScales
	If SupI = -1 OR SupIN(SupI) = 0 Then
		n = 0
		k = CurveI
	Else
		n = SupIN(SupI) - 1
	End If
	ScX = (GW - 1) / (J1C - J0C)
	For I = 0 To n
		If n > 0 Then
			k = SupIJ(SupI, I)
		End If
		DrawCurve(k, I)
	Next
	pnlGraph.Invalidate
End Sub

Sub DrawCurve(Ic As Int,I As Int)
	Dim J, x0, x1, y0, y1 As Int

	DrawCurveName(Ic,I)
	If ScaleMan = 0 Then
		ScMin = CurveScMinA(Ic)
		ScMax = CurveScMaxA(Ic)
	Else
		ScMin = CurveScMinM(Ic)
		ScMax = CurveScMaxM(Ic)
	End If
	
	ScY = (GH - 1) / (ScMax - ScMin)
	
	x0 = GX0
	y0 = GY0 + GH - ScY * (Curve(Ic, J0C) - ScMin) - 1
	For J = J0C To J1C
		x1 = GX0 + (J - J0C) * ScX
		y1 = GY1 - ScY * (Curve(Ic, J) - ScMin) - 1
		cvsGraph.DrawLine(x0, y0, x1, y1, ColCurve(I), WidthCurve(I))
		x0 = x1
		y0 = y1
	Next 
End Sub

Sub DrawCalcMinMax(Ic As Int)
	Dim I As Int
	
	CurveMin(Ic) = Curve(Ic,J0C)
	CurveMax(Ic) = Curve(Ic,J0C)
	For I=J0C To J1C
		If Curve(Ic,I) < CurveMin(Ic) Then CurveMin(Ic) = Curve(Ic,I)
		If Curve(Ic,I) > CurveMax(Ic) Then CurveMax(Ic) = Curve(Ic,I)
	Next
	
	CurveMaxMin(Ic) = CurveMax(Ic) - CurveMin(Ic)
	
	If Abs(CurveMaxMin(Ic)) < 0.000000000001 Then
		If CurveMin(Ic) > 0 Then
			CurveMaxMin(Ic) = CurveMax(Ic)
			CurveMin(Ic) = 0
		Else If CurveMin(Ic) < 0 Then
			CurveMax(Ic) = 0
			CurveMaxMin(Ic) = -CurveMin(Ic)
		Else
			CurveMax(Ic) = 1
			CurveMaxMin(Ic) = 1
		End If
	End If
End Sub

Sub DrawCalcScaleX
	Select CurveAbscissaType
	Case 0 'Abscissa time
		If CurveTime(0) <> Main.TdtC Then
			DrawInitAbscissa
		End If
		Main.TddC = CurveDeg(0)
	Case 1 'Abscissa degrees
		If CurveDeg(0) <> Main.TddC Then
			DrawInitAbscissa
		End If
		Main.TdtC = CurveTime(0)
	Case 2 'Abscissa indexes
		If CurveDeg(0) <> Main.TddC Then
			DrawInitAbscissa
		End If
		Main.TdtC = CurveTime(0)
	End Select
	DrawCalcMinMax(0)
    
	DrawCalcScaleDiv(0,"X")

	If ScXNb = 0 Then
		ScXNb = 18
	End If
	ScNbDiv = ScXNb
	If Abs(CurveMaxMin(0) - CurveScDA(0) * ScNbDiv) < 0.000000001 AND Calc.FRAC(CurveMin(0) / (CurveScDA(0) - 0.00000000002)) < 0.000001 Then
		ScNbDivOcc = ScNbDiv
	Else
		ScNbDivOcc = Calc.Fix(CurveMax(0) / CurveScDA(0) - 0.000000001) - Calc.Fix(CurveMin(0) / CurveScDA(0)) + 1
		Do While ScNbDivOcc > ScNbDiv
		If ScNbDivOcc <= ScNbDiv Then Exit
			ScLog = Logarithm(CurveScDA(0), 10)
			ScExp = Floor(ScLog + 0.000000001)
			ScMant = ScLog - ScExp
			If CurveAbscissaType=1 AND ScExp = 1 Then
				If Abs(ScMant - Logarithm(1, 10)) < 0.0001 Then
					CurveScDA(0) = Power(1.5 * 10, ScExp)
				Else
					If Abs(ScMant - Logarithm(1.5, 10)) < 0.0001 Then
						CurveScDA(0) = Power(1.8 * 10, ScExp)
					Else
						If Abs(ScMant - Logarithm(1.8, 10)) < 0.0001 Then
						CurveScDA(0) = Power(2 * 10, ScExp)
						Else
							If Abs(ScMant - Logarithm(2, 10)) < 0.0001 Then
								CurveScDA(0) = Power(3 * 10, ScExp)
							Else
								If Abs(ScMant - Logarithm(3, 10)) < 0.0001 Then
									CurveScDA(0) = Power(4.5 * 10, ScExp)
								Else
									If Abs(ScMant - Logarithm(4.5, 10)) < 0.0001 Then
										CurveScDA(0) = Power(6 * 10, ScExp)
									Else
										If Abs(ScMant - Logarithm(6, 10)) < 0.0001 Then
											CurveScDA(0) = Power(9 * 10, ScExp)
										Else
											If Abs(ScMant - Logarithm(9, 10)) < 0.0001 Then
												CurveScDA(0) = Power(10 * 10, ScExp)
											End If
										End If
									End If
								End If
							End If
						End If
					End If
				End If
			Else
				If Abs(ScMant - Logarithm(1, 10)) < 0.0001 Then
					CurveScDA(0) = Power(2 * 10, ScExp)
				Else
					If Abs(ScMant - Logarithm(2, 10)) < 0.0001 Then
						CurveScDA(0) = Power(2.5 * 10, ScExp)
					Else
						If Abs(ScMant - Logarithm(2.5, 10)) < 0.0001 Then
							CurveScDA(0) = Power(5 * 10, ScExp)
						Else
							If Abs(ScMant - Logarithm(5, 10)) < 0.0001 Then
								CurveScDA(0) = Power(10 * 10, ScExp)
							End If
						End If
					End If
				End If
			End If
		Loop
	End If
	ScNbDiv = ScNbDivOcc
	ScMin = Floor((Curve(0,J0C) + CurveScDA(0) * 0.999999) / CurveScDA(0)) * CurveScDA(0)
	ScBeginGrid = Floor((ScMin - Curve(0,J0C)) / CurveScDA(0) * GdX)
	
	GW = Floor(CurveMaxMin(0) / CurveScDA(0) * GdX) + 1
	GX1 = GX0 + GW
	rectGrid.Initialize(GX0, GY0, GX1, GY1)
	Dim h As Float
	h = cvsGraph.MeasureStringHeight("Aj", Typeface.DEFAULT, 12) + 5dip
	rectCurveValues.Initialize(GX1 - 200dip, GY0 - 5 * h, GX1, GY0)
	rectAbscissaValues.Initialize(GX0, GY1 + h, GX0 + 300dip, GY1 + 2.2 * h )
		
	If (Curve(0,J1C) - Curve(0,J0C)) = 0 Then
		DrawInitAbscissa
	End If
	ScX = GW / (Curve(0,J1C) - Curve(0, J0C))
End Sub

Sub DrawCalcScaleDiv(Ic As Int, Tt As String)
  Dim Log1, Log12, Log15, Log18, Log2 As Double
	Dim Log25, Log3, Log36, Log45, Log5, Log6, Log9, Log10 As Double
	Dim nbMin, NbUsedIntervalsTop, NbUsedIntervalsBottom, NbUsedIntervals, NbIntervalsToMove As Int
	
  If Tt = "Y" Then
    ScNb = ScYNb
  Else If Tt = "X" Then
    ScNb = ScXNb
  End If
	
	If CurveMax(Ic) = 0 AND CurveMin(Ic) = 0 Then
		CurveMax(Ic) = 1
	End If

  CurveScDA(Ic) = CurveMaxMin(Ic) / ScNb
  
	Log1 = 0.00000000000001
	Log12 = Logarithm(1.2, 10) + 0.00000000000001
	Log15 = Logarithm(1.5, 10) + 0.00000000000001
	Log18 = Logarithm(1.8, 10) + 0.00000000000001
	Log2 = Logarithm(2, 10) + 0.00000000000001
	Log25 = Logarithm(2.5, 10) + 0.00000000000001
	Log3 = Logarithm(3, 10) + 0.00000000000001
	Log36 = Logarithm(3.6, 10) + 0.00000000000001
	Log45 = Logarithm(4.5, 10) + 0.00000000000001
	Log5 = Logarithm(5, 10) + 0.00000000000001
	Log6 = Logarithm(6, 10) + 0.00000000000001
	Log9 = Logarithm(9, 10) + 0.00000000000001
	Log10 = Logarithm(10, 10) + 0.00000000000001

	ScLog = Logarithm(CurveScDA(Ic), 10)
  ScExp = Floor(ScLog)
  If CurveScDA(Ic) >= 1 Then
    ScMant = ScLog - ScExp
  Else
    ScMant = Abs(ScExp) + ScLog 
  End If

	If CurveAbscissaType = 1 AND Tt = "X" AND ScExp = 1 Then
		If ScMant <= Log1 Then
			ScMant = 0
		Else If ScMant > 0 AND ScMant <= Log15 Then
			ScMant = Logarithm(1.5, 10)
		Else If ScMant > Log15 AND ScMant <= Log18 Then
			ScMant = Logarithm(1.8, 10)
		Else If ScMant > Log18 AND ScMant <= Log2 Then
			ScMant = Logarithm(2, 10)
		Else If ScMant > Log2 AND ScMant <= Log3 Then
			ScMant = Logarithm(3, 10)
		Else If ScMant > Log3 AND ScMant <= Log45 Then
			ScMant = Logarithm(4.5, 10)
		Else If ScMant > Log45 AND ScMant < Log6 Then
			ScMant = Logarithm(6, 10)
		Else If ScMant > Log6 AND ScMant < Log9 Then
			ScMant = Logarithm(9, 10)
		Else If ScMant > Log9 AND ScMant < Log10 Then
			ScMant = 1
		End If
	Else If CurveAbscissaType=1 AND Tt = "X" AND ScExp=2 Then
		If ScMant <= Log1 Then
			ScMant = 0
		Else If ScMant > 0 AND ScMant <= Log12 Then
			ScMant = Logarithm(1.2, 10)
		Else If ScMant > Log12 AND ScMant <= Log18 Then
			ScMant = Logarithm(1.8, 10)
		Else If ScMant > Log18 AND ScMant <= Log36 Then
			ScMant = Logarithm(3.6, 10)
		Else If ScMant > Log36 AND ScMant <= Log45 Then
			ScMant = Logarithm(4.5, 10)
		Else If ScMant > Log45 AND ScMant < Log6 Then
			ScMant = Logarithm(6, 10)
		Else If ScMant > Log6 AND ScMant < Log9 Then
			ScMant = Logarithm(9, 10)
		Else If ScMant > Log9 AND ScMant < Log10 Then
			ScMant = 1
		End If
	Else
		If ScMant <= Log1 Then
			ScMant = 0
    Else If ScMant > 0 AND ScMant <= Log2 Then
      ScMant = Logarithm(2, 10)
    Else If ScMant > Log2 AND ScMant <= Log25 Then
      ScMant = Logarithm(2.5, 10)
    Else If ScMant > Log25 AND ScMant <= Log5 Then
      ScMant = Logarithm(5, 10)
    Else If ScMant > Log5 AND ScMant < Log10 Then
      ScMant = 1
    End If
	End If
	
  CurveScDA(Ic) = Power(10, (ScMant + ScExp))
	
	If CurveMin(Ic) < 0 AND CurveMax(Ic) > 0 Then
		NbUsedIntervalsTop = Ceil(CurveMax(Ic) / CurveScDA(Ic) - 0.00000000000001)
		NbUsedIntervalsBottom = Ceil(Abs(CurveMin(Ic)) / CurveScDA(Ic) - 0.00000000000001)
		If NbUsedIntervalsTop + NbUsedIntervalsBottom > ScNb Then
			If CurveAbscissaType = 1 AND Tt = "X" AND ScExp = 1 Then
				If ScMant <= Log1 Then
					ScMant = Logarithm(1.5, 10)
				Else If ScMant > 0 AND ScMant <= Log15 Then
					ScMant = Logarithm(1.8, 10)
				Else If ScMant > Log15 AND ScMant <= Log18 Then
					ScMant = Logarithm(2, 10)
				Else If ScMant > Log18 AND ScMant <= Log2 Then
					ScMant = Logarithm(3, 10)
				Else If ScMant > Log2 AND ScMant <= Log3 Then
					ScMant = Logarithm(4.5, 10)
				Else If ScMant > Log3 AND ScMant <= Log45 Then
					ScMant = Logarithm(6, 10)
				Else If ScMant > Log45 AND ScMant < Log6 Then
					ScMant = Logarithm(9, 10)
				Else If ScMant > Log6 AND ScMant < Log9 Then
					ScMant = 1
				Else If ScMant > Log9 AND ScMant < Log10 Then
					ScMant = Logarithm(15, 10)
				End If
			Else If CurveAbscissaType=1 AND Tt = "X" AND ScExp=2 Then
				If ScMant <= Log1 Then
					ScMant = Logarithm(1.2, 10)
				Else If ScMant > 0 AND ScMant <= Log12 Then
					ScMant = Logarithm(1.8, 10)
				Else If ScMant > Log12 AND ScMant <= Log18 Then
					ScMant = Logarithm(3.6, 10)
				Else If ScMant > Log18 AND ScMant <= Log36 Then
					ScMant = Logarithm(4.5, 10)
				Else If ScMant > Log36 AND ScMant <= Log45 Then
					ScMant = Logarithm(6, 10)
				Else If ScMant > Log45 AND ScMant < Log6 Then
					ScMant = Logarithm(9, 10)
				Else If ScMant > Log6 AND ScMant < Log9 Then
					ScMant = 1
				Else If ScMant > Log9 AND ScMant < Log10 Then
					ScMant = Logarithm(12, 10)
				End If
			Else
				If ScMant <= Log1 Then
					ScMant = Logarithm(2, 10)
		    Else If ScMant > 0 AND ScMant <= Log2 Then
		      ScMant = Logarithm(2.5, 10)
		    Else If ScMant > Log2 AND ScMant <= Log25 Then
		      ScMant = Logarithm(5, 10)
		    Else If ScMant > Log25 AND ScMant <= Log5 Then
		      ScMant = 1
		    Else If ScMant > Log5 AND ScMant < Log10 Then
		      ScMant = Logarithm(20, 10)
		    End If
			End If
			CurveScDA(Ic) = Power(10, ScExp + ScMant)
		End If
	End If
	
	nbMin = Floor(CurveMin(Ic) / CurveScDA(Ic))
	If Abs(CurveMin(Ic)) <= 0.0000000000001 Then
		CurveScMinA(Ic) = 0
	Else If CurveMin(Ic) >= 0 Then
		CurveScMinA(Ic) = nbMin * CurveScDA(Ic)
	Else If CurveMin(Ic) < 0 AND CurveMax(Ic) > 0 Then
		CurveScMinA(Ic) = Floor(CurveMin(Ic) / CurveScDA(Ic) + 0.00000000000001) * CurveScDA(Ic)
	Else
		CurveScMinA(Ic) = Floor(CurveMin(Ic) / CurveScDA(Ic) + 0.00000000000001) * CurveScDA(Ic)
	End If
	
	If Abs(CurveScMinA(Ic)) > 0.0000000000001 Then
		If CurveMin(Ic) < 0 AND CurveMax(Ic) > 0 Then
			NbUsedIntervalsTop = Ceil(CurveMax(Ic) / CurveScDA(Ic) - 0.00000000000001)
			NbUsedIntervalsBottom = Ceil(Abs(CurveMin(Ic)) / CurveScDA(Ic) - 0.00000000000001)
			NbUsedIntervals = NbUsedIntervalsTop + NbUsedIntervalsBottom
			If NbUsedIntervalsTop - NbUsedIntervalsBottom = 1 Then
				NbIntervalsToMove = ScNb / 2 - NbUsedIntervalsBottom
			Else
				NbIntervalsToMove = (ScNb - NbUsedIntervals) / 2			
			End If
		Else
			NbUsedIntervals = Ceil(CurveMaxMin(Ic) / CurveScDA(Ic) - 0.00000000000001)
			NbIntervalsToMove = (ScNb - NbUsedIntervals) / 2
		End If
		CurveScMinA(Ic) = CurveScMinA(Ic) - NbIntervalsToMove * CurveScDA(Ic)
	End If
	
	CurveScMaxA(Ic) = CurveScMinA(Ic) + CurveScDA(Ic) * ScNb


	If CurveScMaxM(Ic) = 0 AND CurveScMinM(Ic) = 0 Then
		CurveScMaxM(Ic) = CurveScMaxA(Ic)
		CurveScMinM(Ic) = CurveScMinA(Ic)
		CurveScDM(Ic) = CurveScDA(Ic)
	End If
End Sub

Sub DrawScales
	Dim I, k, ic, sc As Int

	If SupI = -1 Then
		DrawCalcMinMax(CurveI)
		DrawCalcScaleDiv(CurveI,"Y")
		DrawScale(CurveI,0,ColCurve(0))
	Else
		sc = 0
		For I = 0 To SupIN(SupI) - 1
			ic = SupIJ(SupI,I)
			DrawCalcMinMax(ic)
			DrawCalcScaleDiv(ic,"Y")
			If I > 0 Then
				For k = 0 To I - 1
					If ScaleMan = 0 Then
						If CurveScMaxA(ic) <> CurveScMaxA(SupIJ(SupI,k)) OR CurveScMinA(ic) <> CurveScMinA(SupIJ(SupI,k)) Then sc = 1
					Else
						If CurveScMaxM(ic) <> CurveScMaxM(SupIJ(SupI,k)) OR CurveScMinM(ic) <> CurveScMinM(SupIJ(SupI,k)) Then sc = 1
					End If
				Next 
			End If
		Next
		
		If sc = 0 Then
			DrawScale(SupIJ(SupI,0),0,Colors.Black)
		Else
			For I = 0 To SupIN(SupI) - 1
				ic = SupIJ(SupI,I)
				DrawScale(ic, I, ColCurve(I))
			Next
		End If
	End If
End Sub

Sub DrawScale(Ic As Int, i As Int, col As Int)
	Dim j, x As Int
	Dim y, y0 As Int
	Dim v, dv As Double
	Dim st As Int
	Dim fs1, h As Float
	Dim Align, str As String
	
	fs1 = 14
	h = cvsGraph.MeasureStringHeight("0", Typeface.DEFAULT, fs1) + 5dip
	
	st = 1
	If SupI > -1 AND DrawGridSizeI = 2 Then
		If SupIN(SupI) > 2 AND col <> Colors.Black Then	'???????????????
			st = 2
		End If
	End If

	If ScaleMan = 0 Then
		dv = CurveScDA(Ic)
		v = CurveScMinA(Ic) - dv
	Else
		dv = CurveScDM(Ic)
		v = CurveScMinM(Ic) - dv
	End If
	
	Dim mant As Double
	Dim nbd As Int
	mant = Logarithm(dv, 10)
	If mant <0 Then
		nbd = Ceil(Abs(mant))
	Else
		nbd = 0
	End If
	For j = 0 To ScYNb Step st
		v = v + dv
		If Abs(v) < 1e-10 Then
			v = 0
		End If
		str = NumberFormat2(v, 1, 9, nbd, False)
		
		Select i
		Case -1, 0
			x = GX0 - 4dip
			y0 = GY1
			Align = "RIGHT"
		Case 1
			x = GX1 + 4dip
			y0 = GY1
			Align = "LEFT"
		Case 2
			x = GX0 - 4dip
			y0 = GY1 - h
			Align = "RIGHT"
		Case 3
			x = GX1 + 4dip
			y0 = GY1 - h
			Align = "LEFT"
		End Select
		y = y0 - j * GdX + 1dip * 0.5 * fs1
		
		If DrawBitmap = 0 Then
			cvsGrid.DrawText(str, x, y, Typeface.DEFAULT, fs1, col, Align)
		Else
			cvsBmpGraph.DrawText(str, x, y, Typeface.DEFAULT, fs1, col, Align)
		End If
	Next
End Sub

Sub DrawCurveName(Ic As Int, I As Int)
	Dim x, y As Int
	Dim v As String
	Dim fs1, h As Float
	Dim Align As String
	
	fs1 = 14
	h = cvsGraph.MeasureStringHeight("Aj", Typeface.DEFAULT, fs1) + 5dip
	v = Calc.CurveListLine(Ic, "", 1)
	
	y = GY0 - 5dip - I * h
	x = GX0 + 5dip
	Align = "LEFT"
	
	If DrawBitmap = 0 Then
		cvsGraph.DrawText(v, x, y, Typeface.DEFAULT, fs1, ColCurve(I), Align)
	Else
		cvsBmpGraph.DrawText(v, x, y, Typeface.DEFAULT, fs1, ColCurve(I), Align)
	End If
End Sub

Sub DrawCursor(Cc As Int, Mode As Int)
	If Mode = 1 OR Mode = 2 Then
		DrawCursorLine(CursI, 0)
	End If

	CursI = Cc
	If Mode = 0 OR Mode = 1 Then
		DrawCursorLine(CursI, 1)
	End If
End Sub

Sub DrawCursorLine(x As Int, Mode As Int)
	Dim c, i, fs As Int
	Dim x0, y0, n, k ,i0 As Int
	Dim h As Float
	Dim v As Double
	
	If Mode = 0 Then
		c = Colors.Transparent
	Else
		c = Colors.Black
	End If
	rectCursor.Initialize(x - 1, GY0, x + 1, GY1)
	cvsCursor.DrawLine(x, GY0, x, GY1, c, 1)
	pnlCursor.Invalidate2(rectCursor)
	i = J0C + Floor((CursI - GX0) / ScX)
	i = J0C + Floor((CursI - GX0 + .5) / ScX)
	
	If Mode = 0 Then
		cvsCursor.DrawRect(rectCurveValues, Colors.Transparent, True, 1)
		cvsCursor.DrawRect(rectAbscissaValues, Colors.Transparent, True, 1)
	Else
		If SupI = -1 Then
			n = 0
			k = CurveI
		Else
			n = SupIN(SupI) - 1
		End If
	
		fs = 14
		h = cvsGraph.MeasureStringHeight("Aj", Typeface.DEFAULT, fs) + 5dip
		For i0 = 0 To n
			If SupI >= 0 Then
				k = SupIJ(SupI, i0)
			End If
			
			v = Curve(k, i)
			x0 = GX1
			y0 = GY0 - 5dip - i0 * h
			cvsCursor.DrawText(v, x0, y0, Typeface.DEFAULT, fs, ColCurve(i0), "RIGHT")
		Next
		y0 = GY1 + 1.6 * h
		x0 = GX0 + cvsGraph.MeasureStringWidth("2222", Typeface.DEFAULT, fs)
		cvsCursor.DrawText(i, x0, y0, Typeface.DEFAULT, fs, Colors.Black, "RIGHT")
		
		x0 = GX0 + cvsGraph.MeasureStringWidth("222222222", Typeface.DEFAULT, fs)
		v = Curve(0, i)
		cvsCursor.DrawText(v, x0, y0, Typeface.DEFAULT, fs, Colors.Blue, "LEFT")
	End If
	pnlCursor.Invalidate2(rectCurveValues)
	pnlCursor.Invalidate2(rectAbscissaValues)
End Sub

Sub pnlCursor_Touch (Action As Int, X As Float, Y As Float)
	Dim f As Double

	Select Action
	Case Activity.ACTION_DOWN
		If X > GX0 AND X < GX1 AND Y > GY0 AND Y < GY1 Then
			If flagZoom = 1 Then
				NJ0p = X
				rectZoom0.Initialize(NJ0p - 1, GY0, NJ0p + 1, GY1)
				cvsCursor.DrawLine(NJ0p, GY0, NJ0p, GY1, Colors.Blue, 1)
				pnlCursor.Invalidate2(rectZoom0)
				flagZoom = 2
			Else If flagZoom = 3 Then
				NJ1p = X				
				rectZoom1.Initialize(NJ1p - 1, GY0, NJ1p + 1, GY1)
				cvsCursor.DrawLine(NJ1p, GY0, NJ1p, GY1, Colors.Blue, 1)
				pnlCursor.Invalidate2(rectZoom1)
				flagZoom=4
			Else If FlagTimeFreq > 0 Then
				If FlagTimeFreq = 1 Then
					Tfci = 0
					Tfcp(Tfci) = X
					rectZoom0.Initialize(Tfcp(Tfci) - 1, GY0, Tfcp(Tfci) + 1, GY1)
					cvsCursor.DrawLine(Tfcp(Tfci), GY0, Tfcp(Tfci), GY1, Colors.Blue, 1)
					pnlCursor.Invalidate2(rectZoom0)
					FlagTimeFreq = 2
				Else If FlagTimeFreq = 3 OR FlagTimeFreq = 5 Then
					If X < Tfcp(0) OR X < Tfcp(1) AND (X - Tfcp(0)) < (Tfcp(1) - X) Then
						Tfci = 0
					Else
						Tfci = 1
					End If
					If FlagTimeFreq = 5 Then
						cvsCursor.DrawLine(Tfcp(Tfci), GY0, Tfcp(Tfci), GY1, Colors.Transparent, 1)
						pnlCursor.Invalidate2(rectZoom0)
					End If
					Tfcp(Tfci) = X
					rectZoom0.Initialize(Tfcp(Tfci) - 1, GY0, Tfcp(Tfci) + 1, GY1)
					cvsCursor.DrawLine(Tfcp(Tfci), GY0, Tfcp(Tfci), GY1, Colors.Blue, 1)
					pnlCursor.Invalidate2(rectZoom0)
					FlagTimeFreq = 4
					
					If Tfcp(0) <> Tfcp(1) Then
						cvsCursor.DrawLine(Tfcp(Tfci), GY0, Tfcp(Tfci), GY1, Colors.Transparent, 1)
						pnlCursor.Invalidate2(rectZoom0)
					End If
					Tfcp(Tfci) = X
					rectZoom0.Initialize(Tfcp(Tfci) - 1, GY0, Tfcp(Tfci) + 1, GY1)
					cvsCursor.DrawLine(Tfcp(Tfci), GY0, Tfcp(Tfci), GY1, Colors.Blue, 1)
					pnlCursor.Invalidate2(rectZoom0)
					Tfc(Tfci) = Floor((X - GX0) / ScX)
					f = Abs(Tfc(1) - Tfc(0)) * CurveTime(CurveI)
					If f > 0 Then
						Manage.ToolTip(lblToolTip, Main.Text(236) & " f = " & (Round2(1 / f, 2)) & " Hz")
					End If
				End If
			Else
				CursFlag = 1
				DrawCursor(X, 0)
			End If
		End If
	Case Activity.ACTION_MOVE
		If X > GX0 AND X < GX1 AND Y > GY0 AND Y < GY1 Then
			If CursFlag = 1 Then
				DrawCursor(X, 1)
			Else If flagZoom = 2 Then
				cvsCursor.DrawLine(NJ0p, GY0, NJ0p, GY1, Colors.Transparent, 1)
				pnlCursor.Invalidate2(rectZoom0)
				NJ0p = X
				rectZoom0.Initialize(NJ0p - 1, GY0, NJ0p + 1, GY1)
				cvsCursor.DrawLine(NJ0p, GY0, NJ0p, GY1, Colors.Blue, 1)
				pnlCursor.Invalidate2(rectZoom0)
			Else If flagZoom = 4 Then
				cvsCursor.DrawLine(NJ1p, GY0, NJ1p, GY1, Colors.Transparent, 1)
				pnlCursor.Invalidate2(rectZoom1)
				NJ1p=X
				rectZoom1.Initialize(NJ1p - 1, GY0, NJ1p + 1, GY1)
				cvsCursor.DrawLine(NJ1p, GY0, NJ1p, GY1, Colors.Blue, 1)
				pnlCursor.Invalidate2(rectZoom1)
			Else If FlagTimeFreq > 1 Then
				If FlagTimeFreq = 2 Then
					cvsCursor.DrawLine(Tfcp(Tfci), GY0, Tfcp(Tfci), GY1, Colors.Transparent, 1)
					pnlCursor.Invalidate2(rectZoom0)
					Tfcp(Tfci) = X
					rectZoom0.Initialize(Tfcp(Tfci) - 1, GY0,Tfcp(Tfci) + 1, GY1)
					cvsCursor.DrawLine(Tfcp(Tfci), GY0, Tfcp(Tfci), GY1, Colors.Blue, 1)
					pnlCursor.Invalidate2(rectZoom0)
				Else If FlagTimeFreq = 4 Then
					If Tfcp(0) <> Tfcp(1) Then
						cvsCursor.DrawLine(Tfcp(Tfci), GY0, Tfcp(Tfci), GY1, Colors.Transparent, 1)
						pnlCursor.Invalidate2(rectZoom0)
					End If
					Tfcp(Tfci) = X
					rectZoom0.Initialize(Tfcp(Tfci) - 1, GY0,Tfcp(Tfci) + 1, GY1)
					cvsCursor.DrawLine(Tfcp(Tfci), GY0, Tfcp(Tfci), GY1, Colors.Blue, 1)
					pnlCursor.Invalidate2(rectZoom0)
					Tfc(Tfci) = Floor((X-GX0)/ScX)
					f = Abs(Tfc(1) - Tfc(0)) * CurveTime(CurveI)
					If f > 0 Then
						Manage.ToolTip(lblToolTip, Main.Text(236) & " f = " & (Round2(1 / f, 2)) & " Hz")
					End If
				End If
			End If
		End If	
	Case Activity.ACTION_UP
		Dim v As Double
	
		If CursFlag =1 Then
			CursFlag = 0
			DrawCursor(X, 2)
		Else If flagZoom = 2 Then
			NJ0 = Max(0, Floor((X - GX0) / ScX))
			flagZoom = 3
			Manage.ToolTip(lblToolTip, "Position the cursor at the end of the zoom area")
		Else If flagZoom = 4 Then
			J1C = Min(CurveSampleNb, Floor((X - GX0) / ScX) + J0C)
			J1C = Max(0, J1C)
			J0C = NJ0 + J0C
			JwC = J1C - J0C
			flagZoom = 0
			cvsCursor.DrawLine(NJ0p, GY0, NJ0p, GY1, Colors.Transparent, 1)
			pnlCursor.Invalidate2(rectZoom0)
			cvsCursor.DrawLine(NJ1p, GY0, NJ1p, GY1, Colors.Transparent, 1)
			pnlCursor.Invalidate2(rectZoom1)
			Manage.ToolTip(lblToolTip, "")
			If J1C < J0C Then
				Dim ii As Int
				ii = J0C
				J0C = J1C
				J1C = ii
			End If
			ZoomInit
			Zoomed = True
			Dim bdw As BitmapDrawable 
			bdw.Initialize(LoadBitmap(File.DirAssets, "btnZoomIn0.png"))
			btnZoom.Background = bdw
			btnZoom.Tag = "Off"
		Else If FlagTimeFreq > 0 AND X > GX0 AND X < GX1 AND Y > GY0 AND Y < GY1 Then
			If FlagTimeFreq = 2 Then
				Tfc(Tfci) = Floor((X - GX0) / ScX)
				Manage.ToolTip(lblToolTip, "Select the right time position on the screen.")				
				FlagTimeFreq = 3
			Else If FlagTimeFreq = 4 Then
				FlagTimeFreq = 5
				If Tfc(0) > Tfc(1) Then
					v = Tfc(0)
					Tfc(0) = Tfc(1)
					Tfc(1) = v
					v = Tfcp(0)
					Tfcp(0) = Tfcp(1)
					Tfcp(1) = v
				End If 
			End If
		End If
	End Select
End Sub

Sub pnlZoomScroll_Touch (Action As Int, X As Float, Y As Float)
	Select Action
	Case Activity.ACTION_DOWN
		If X >= 0 AND X < ZJ0 Then
			flagZoomScroll = -1
		Else If X >= ZJ0 AND X <= ZJ1 Then
			Zd = X - ZJ0
			flagZoomScroll = 2
		Else If X > ZJ1 AND X < pnlZoomScroll.Width Then
			flagZoomScroll = 1	
		End If
	Case Activity.ACTION_MOVE
		If flagZoomScroll = 2 Then
			cvsZoomScroll.DrawRect(rectZoomCursor, Colors.Transparent, True, 1)
			pnlZoomScroll.Invalidate2(rectZoomCursor)
			ZJ0 = X - Zd
			If ZJ0 < 0 Then
				ZJ0 = 0
			End If
			If ZJ0 > ZJMax Then
				ZJ0 = ZJMax
			End If
			ZJ1 = ZJ0 + ZW
			J0C = ZJ0 * CurveSampleNb / pnlZoomScroll.Width
			J1C = J0C + JwC
			rectZoomCursor.Initialize(ZJ0, pnlZoomScroll.Height - 16dip, ZJ1, pnlZoomScroll.Height - 4dip)
			cvsZoomScroll.DrawRect(rectZoomCursor, Colors.Blue, True, 1)
			pnlZoomScroll.Invalidate2(rectZoomCursor)
			edtZoomJ0.Text = J0C
			edtZoomJ1.Text = J1C
			DrawZoom
		End If
	Case Activity.ACTION_UP
		If Abs(flagZoomScroll) = 1 Then
			cvsZoomScroll.DrawRect(rectZoomCursor, Colors.Transparent, True, 1)
			pnlZoomScroll.Invalidate2(rectZoomCursor)
			J0C = Max(0, J0C + JdC * flagZoomScroll)
			If J0C > CurveSampleNb - JwC Then
				J0C = CurveSampleNb - JwC
			End If
			J1C = J0C + JwC
			ZJ0 = J0C * pnlZoomScroll.Width / CurveSampleNb
			ZJ1 = ZJ0 + ZW
			rectZoomCursor.Initialize(ZJ0, pnlZoomScroll.Height - 16dip, ZJ1, pnlZoomScroll.Height - 4dip)
			cvsZoomScroll.DrawRect(rectZoomCursor, Colors.Blue, True, 1)
			pnlZoomScroll.Invalidate2(rectZoomCursor)
			edtZoomJ0.Text = J0C
			edtZoomJ1.Text = J1C
			DrawZoom
		End If
	End Select
End Sub

Sub btnCalc_Touch (Action As Int, X As Float, Y As Float)
	Manage.ToggleButtonClick(Me, btnCalc, Action, X, Y, lblToolTip, "Show the calc functions", "Hide the calc functions", "btnCalc", "btnCalcDo0", "btnCalcDo1", False)
End Sub

Sub btnCalcDo0
	pnlToolboxCurveCalc.Visible = True
End Sub

Sub btnCalcDo1
	pnlToolboxCurveCalc.Visible = False
End Sub

Sub btnZoom_Touch (Action As Int, X As Float, Y As Float)
	Manage.txtPermanentToolTip = "Position the cursor at the beginning of the zoom area"
	Manage.ToggleButtonClick(Me, btnZoom, Action, X, Y, lblToolTip, "Activate the zoom function", "Cancel the zoom function", "btnZoomIn", "btnZoomDo0", "btnZoomDo1", True)
End Sub

Sub btnZoomDo0
	If flagZoom = 0 Then
		flagZoom = 1
	Else
		flagZoom = 0
	End If
End Sub

Sub btnZoomDo1
	flagZoom = 0
End Sub

Sub btnUnZoom_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnUnZoom, Action, X, Y, lblToolTip, "Sets 100% graphic", "btnZoom100_", "btnUnZoomDo", False)
End Sub

Sub btnUnZoomDo
	J0C = 0
	J1C = CurveSampleNb
	JwC = CurveSampleNb
	DrawInitAbscissa
	DrawInitZoomScrollBar
	DrawCurves(SupI)
	Zoomed = False
	pnlZoom.Visible = False
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Returns to main srceen", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub btnHelp_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnHelp, Action, X, Y, lblToolTip, "Displays the help screen", "btnHelp", "btnHelpDo", False)
End Sub

Sub btnHelpDo
	Help.HelpFile = "dynsimgraphhelp.htm"
	StartActivity("Help")
End Sub

Sub btnCalcDifference_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalcDifference, Action, X, Y, lblToolTip, "Calculate the difference of two curves", "btnCalcDiff", "btnCalcDifferenceDo", False)
End Sub

Sub btnCalcDifferenceDo
	GraphCalc.OpI = GraphCalc.cCalcDiff
	StartActivity(GraphCalc)
End Sub

Sub btnCalcDivision_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalcDivision, Action, X, Y, lblToolTip, "Calculate the division of two curves", "btnCalcDivision", "btnCalcDivisionDo", False)
End Sub

Sub btnCalcDivisionDo
	GraphCalc.OpI = GraphCalc.cCalcQuot
	StartActivity(GraphCalc)
End Sub

Sub btnCalcSum_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalcSum, Action, X, Y, lblToolTip, "Calculate the sum of two curves", "btnCalcSum", "btnCalcSumDo", False)
End Sub

Sub btnCalcSumDo
	GraphCalc.OpI = GraphCalc.cCalcSum
	StartActivity(GraphCalc)
End Sub

Sub btnCalcProduct_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalcProduct, Action, X, Y, lblToolTip, "Calculate the product of two curves", "btnCalcProduct", "btnCalcProductDo", False)
End Sub

Sub btnCalcProductDo
	GraphCalc.OpI = GraphCalc.cCalcMult
	StartActivity(GraphCalc)
End Sub

Sub btnCalcIntegral_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalcIntegral, Action, X, Y, lblToolTip, "Calculate the integral of the seleted curve", "btnCalcIntegral", "btnCalcIntegralDo", False)
End Sub

Sub btnCalcIntegralDo
	GraphCalcIntegral.cGraphCalcOpI = GraphCalcIntegral.cGraphCalcIntegral
	StartActivity(GraphCalcIntegral)
End Sub

Sub btnCalcDerivative_Touch(Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalcDerivative, Action, X, Y, lblToolTip, "Calculate the derivative of the seleted curve", "btnCalcDerivative", "btnCalcDerivativeDo", False)
End Sub

Sub btnCalcDerivativeDo
	GraphCalcIntegral.cGraphCalcOpI = GraphCalcIntegral.cGraphCalcDerivative
	StartActivity(GraphCalcIntegral)
End Sub

Sub btnCalcMean_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalcMean, Action, X, Y, lblToolTip, "Calculate mean values of the selected curve", "btnCalcMean", "btnCalcMeanDo", False)
End Sub

Sub btnCalcMeanDo
	StartActivity(GraphCalcMean)
End Sub

Sub btnConvertTimeFreq_Touch (Action As Int, X As Float, Y As Float)
	Manage.ToggleButtonClick(Me,btnConvertTimeFreq, Action, X, Y, lblToolTip, "Activate the time to frequency conversion function", "Cancel the time to frequency conversion function", "btnConvertTimeFreq", "btnConvertTimeFreqDo0", "btnConvertTimeFreqDo1", False)
End Sub

Sub btnConvertTimeFreqDo0
	If FlagTimeFreq = 0 Then
		FlagTimeFreq = 1
		CallSubDelayed2(Me, "ToolTip", "Position the cursor at the beginning of the time area")
	Else
		FlagTimeFreq = 0
	End If
End Sub

Sub btnConvertTimeFreqDo1
	rectZoom0.Initialize(Tfcp(0) - 1, GY0,Tfcp(0) + 1, GY1)
	cvsCursor.DrawLine(Tfcp(0), GY0, Tfcp(0), GY1, Colors.Transparent, 1)
	pnlCursor.Invalidate2(rectZoom0)
	rectZoom0.Initialize(Tfcp(1) - 1, GY0,Tfcp(1) + 1, GY1)
	cvsCursor.DrawLine(Tfcp(1), GY0, Tfcp(1), GY1, Colors.Transparent, 1)
	pnlCursor.Invalidate2(rectZoom0)
	FlagTimeFreq = 0
	Manage.ToolTip(lblToolTip, "")
End Sub

Sub btnCurveOffset_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCurveOffset, Action, X, Y, lblToolTip, "Change the offset of the selected curve", "btnOffset", "btnCurveOffsetDo", False)
End Sub

Sub btnCurveOffsetDo
	FlagGraphCalc = cOffset
	StartActivity(GraphCalcOffset)
End Sub

Sub btnCurveGain_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCurveGain, Action, X, Y, lblToolTip, "Change the gain of the selected curve", "btnSuperposeCurves", "btnCurveGainDo", False)
End Sub

Sub btnCurveGainDo
	FlagGraphCalc = cGain
	StartActivity(GraphCalcOffset)
End Sub

Sub btnScales_Touch (Action As Int, X As Float, Y As Float)
	Manage.ToggleButtonClick(Me, btnScales, Action, X, Y, lblToolTip, "Show the Scales toolbox", "Hide the Scales toolbox", "btnScaleAuto", "btnScalesDo0", "btnScalesDo1", False)
End Sub

Sub btnScalesDo0
	pnlToolBoxScales.Visible = True

	Dim bdw As BitmapDrawable
	If ScaleMan = 0 Then
		bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleAuto1.png"))
	Else
		bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleManuel1.png"))
	End If
	btnScales.Background = bdw

End Sub

Sub btnScalesDo1
	pnlToolBoxScales.Visible = False

	Dim bdw As BitmapDrawable
	If ScaleMan = 0 Then
		bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleAuto0.png"))
	Else
		bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleManuel0.png"))
	End If
	btnScales.Background = bdw
	btnScales.Tag = "Off"
End Sub

Sub btnScaleAuto_Touch (Action As Int, X As Float, Y As Float)
	Manage.ToggleButtonClick(Me,btnScaleAuto, Action, X, Y, lblToolTip, "Show the Scales toolbox", "Hide the Scales toolbox", "btnScaleAuto", "btnScaleAutoDo", "btnScaleAutoDo", False)
End Sub

Sub btnScaleAutoDo
	ScaleMan = 0
	
	Dim bdw As BitmapDrawable
	bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleAuto1.png"))
	btnScaleAuto.Background = bdw
	
	Dim bdw As BitmapDrawable
	bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleManuel0.png"))
	btnScaleManuel.Background = bdw	
	
	Manage.ToggleButtonClick(Me, btnScales, 1, 1, 1, lblToolTip, "Show the Scales toolbox", "Hide the Scales toolbox", "btnScaleAuto", "btnScalesDo0", "btnScalesDo1", False)
	DrawCurves(SupI)
End Sub

Sub btnScaleManuel_Touch (Action As Int, X As Float, Y As Float)
	Manage.ToggleButtonClick(Me,btnScaleManuel, Action, X, Y, lblToolTip, "Show the Scales toolbox", "Hide the Scales toolbox", "btnscalemanuel", "btnScaleManuelDo", "btnScaleManuelDo", False)
End Sub

Sub btnScaleManuelDo
	ScaleMan = 1

	Dim bdw As BitmapDrawable
	bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleManuel1.png"))
	btnScaleManuel.Background = bdw	

	Dim bdw As BitmapDrawable
	bdw.Initialize(LoadBitmap(File.DirAssets, "btnScaleAuto0.png"))
	btnScaleAuto.Background = bdw
	
	Manage.ToggleButtonClick(Me, btnScales, 1, 1, 1, lblToolTip, "Show the Scales toolbox", "Hide the Scales toolbox", "btnScaleAuto", "btnScalesDo0", "btnScalesDo1", False)
	DrawCurves(SupI)
End Sub

Sub btnScaleChange_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnScaleChange, Action, X, Y, lblToolTip, "Change scales", "btnScaleChange", "btnScaleChangeDo", False)
End Sub

Sub btnScaleChangeDo
	ScaleMan = 1
	btnScaleManuelDo
	btnScalesDo0
	StartActivity(ScaleChange)
End Sub

Sub btnCurveUp_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCurveUp, Action, X, Y, lblToolTip, "Dispays the previous curve", "btnArrowUp", "btnCurveUpDo", False)
End Sub

Sub btnCurveUpDo
	If CurveI > CurveStep Then
		CurveI = CurveI - CurveStep
		SupI = -1
		cbbCurves.SelectedIndex = CurveI - 1
		DrawCurves(SupI)
	End If
End Sub

Sub btnCurveDown_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCurveDown, Action, X, Y, lblToolTip, "Dispays the next curve", "btnArrowDown", "btnCurveDownDo", False)
End Sub

Sub btnCurveDownDo
	If CurveI < cbbCurves.Size - CurveStep - 1 Then
		CurveI = CurveI + CurveStep
		SupI = -1
		cbbCurves.SelectedIndex = CurveI - 1
		DrawCurves(SupI)
	End If
End Sub

Sub btnSaveCurves_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnSaveCurves, Action, X, Y, lblToolTip, "Save curves to a file", "btnsavecurves", "btnSaveCurvesDo", False)
End Sub

Sub btnSaveCurvesDo
	StartActivity(GraphSaveCurves)
End Sub

Sub btnConfigGraph_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnConfigGraph, Action, X, Y, lblToolTip, "Configure the graphics", "btnconfiggraph", "btnConfigGraphDo", False)
End Sub

Sub btnConfigGraphDo
	StartActivity(GraphSetup)
End Sub

Sub btnEditCurveValues_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnEditCurveValues, Action, X, Y, lblToolTip, "Edit curve values", "btncurvevalueedit", "btnEditCurveValuesDo", False)
End Sub

Sub btnEditCurveValuesDo
	StartActivity(GraphEditCurve)
End Sub

Sub btnLoadCurves_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnLoadCurves, Action, X, Y, lblToolTip, "Load a curve file", "btnloadcurves", "btnLoadCurvesDo", False)
End Sub

Sub btnLoadCurvesDo
	StartActivity(GraphLoadCurves)
End Sub

Sub btnSuperposUp_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnSuperposUp, Action, X, Y, lblToolTip, "Dispays the previous superposition", "btnArrowUp", "btnSuperposUpDo", False)
End Sub

Sub btnSuperposUpDo
	Dim I As Int
	
	If SupI > 0 Then
		I = SupI - 1
		Do While SupIN(I) = 0 AND I > 0
			I = I - 1
			If SupIN(I) > 0 Then Exit 
		Loop
		If I >= 0 AND SupIN(I) > 0 Then
			SupI = I
			cbbSuperpos.SelectedIndex = SupI
			DrawCurves(SupI)
		End If
	End If
End Sub

Sub btnSuperposDown_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnSuperposDown, Action, X, Y, lblToolTip, "Dispays the next superposition", "btnArrowDown", "btnSuperposDownDo", False)
End Sub

Sub btnSuperposDownDo
	Dim I As Int
	
	If SupI < SupNb - 2 Then
		I = SupI + 1
		Do While SupIN(I) = 0 AND I < SupNb - 1
			I = I + 1
			If SupIN(I) > 0 Then Exit 
		Loop
		If I < SupNb AND SupIN(I) > 0 Then
			SupI = I
			cbbSuperpos.SelectedIndex = SupI
			DrawCurves(SupI)
		End If
	End If
End Sub

Sub btnSuperposCurves_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnSuperposCurves, Action, X, Y, lblToolTip, "Dispays the curve superposition panel", "btnSuperposeCurves", "btnSuperposCurvesDo", False)
End Sub

Sub btnSuperposCurvesDo
	StartActivity(GraphSuperpos)
End Sub

Sub btnCopyCurves_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCopyCurves, Action, X, Y, lblToolTip, "Dispays the curve copy", "btnCopyCurves", "btnCopyCurvesDo", False)
End Sub

Sub btnCopyCurvesDo
	StartActivity(GraphCopyCurves)
End Sub

Sub cbbCurves_ItemClick (Position As Int, Value As Object)
	CurveI = Position + 1
	SupI = -1
	DrawCurves(SupI)
End Sub

Sub cbbSuperpos_ItemClick (Position As Int, Value As Object)
	SupI = Position
	DrawCurves(SupI)	
End Sub

Sub ToolTip(txt As String)
	lblToolTip.Text = txt
	If txt = "" Then
		lblToolTip.Visible = False
	Else
		lblToolTip.Visible = True
	End If
End Sub

Sub edtZoomJ0_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtZoomJ0, "edtZoomJ0_ValueChanged", "Enter J0", "Int+")
	End If
End Sub

Sub edtZoomJ0_ValueChanged(Value As Double)
	J0C = Value
	J1C = J0C + JwC
	If J1C > CurveSampleNb - 1 Then
		J1C = CurveSampleNb - 1
		J0C = J1C - JwC
	End If
	ZoomInit
End Sub

Sub edtZoomJ1_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtZoomJ1, "edtZoomJ1_ValueChanged", "Enter J1", "Int+")
	End If
End Sub

Sub edtZoomJ1_ValueChanged(Value As Double)
	J1C = Value
	J0C = J1C - JwC
	If J0C < 0 Then
		J0C = 0
		J1C = J0C + JwC
	End If
	ZoomInit
End Sub

Sub edtZoomJW_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtZoomJW, "edtZoomJW_ValueChanged", "Enter J width", "Int+")
	End If
End Sub

Sub edtZoomJW_ValueChanged(Value As Double)
	JwC = Value
	J1C = J0C + JwC
	If J1C > CurveSampleNb - 1 Then
		J1C = CurveSampleNb - 1
		J0C = J1C - JwC
	End If
	ZoomInit
End Sub

Sub edtZoomJD_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtZoomJD, "edtZoomJD_ValueChanged", "Enter J delta", "Int+")
	End If
End Sub

Sub edtZoomJD_ValueChanged(Value As Double)
	JdC = Value
	ZoomInit
End Sub

Sub edtCurveStep_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtCurveStep, "edtCurveStep_ValueChanged", "Enter curve step", "Int1+")
	End If
End Sub

Sub edtCurveStep_ValueChanged(Value As Double)
	CurveStep = Value
End Sub
