﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals
' Graph calculation variables
	Dim OpI As Int							:	OpI = 0					' operator index for arithmetic on two curves
	Dim cCalcSum As Int					:	cCalcSum = 0		' constant sum
	Dim cCalcDiff As Int				:	cCalcDiff = 1		' constant difference
	Dim cCalcMult As Int				:	cCalcMult = 2		' constant multiplication
	Dim cCalcQuot As Int				: cCalcQuot = 3		' constant quotient

	Dim J0z, J1z As Int
	Dim Zoomed = False As Boolean
End Sub

Sub Globals
	Dim btnCalculation, btnCalcSum, btnCalcDifference, btnCalcProduct, btnCalcDivision, btnBack As Panel
	Dim pnlZoom As Panel
	Dim cbbCurve1, cbbCurve2, cbbCurve3 As ComboBox
	Dim lblTitle, lblTooltip, lblOperator, lblHelp As Label
	Dim bdw0(4), bdw1(4) As BitmapDrawable
	Dim btnCalc(4) As Panel
	Dim pnlToolbox As Panel
	Dim OpSign() As String			: OpSign = Array As String("+", "-", "x", "/")

	Dim edtJ0, edtJ1, edtDummy As EditText
	Dim rbtZoomed, rbtNotZoomed As RadioButton

	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME

	Dim OpC1 = -1 As Int	' index curve 1		-1 no curve selected
	Dim OpC2 = -1 As Int	' index curve 2
	Dim OpC3 = -1 As Int	' index curve 3
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("graphcalc")
	pnlZoom.LoadLayout("zoom")
	
	cbbCurve1.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbCurve1.ItemColor = Colors.RGB(255, 228, 181)
	cbbCurve1.ItemTextColor = Colors.Black
	cbbCurve1.FastScrollEnabled = True
	cbbCurve2.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbCurve2.ItemColor = Colors.RGB(255, 228, 181)
	cbbCurve2.ItemTextColor = Colors.Black
	cbbCurve2.FastScrollEnabled = True
	cbbCurve3.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbCurve3.ItemColor = Colors.RGB(255, 228, 181)
	cbbCurve3.ItemTextColor = Colors.Black
	cbbCurve3.FastScrollEnabled = True
	
	btnCalc = Array As Panel(btnCalcSum, btnCalcDifference, btnCalcProduct, btnCalcDivision)
	
	bdw0(0).Initialize(LoadBitmap(File.DirAssets, "btnCalcSum0.png"))
	bdw1(0).Initialize(LoadBitmap(File.DirAssets, "btnCalcSum1.png"))
	bdw0(1).Initialize(LoadBitmap(File.DirAssets, "btnCalcDiff0.png"))
	bdw1(1).Initialize(LoadBitmap(File.DirAssets, "btnCalcDiff1.png"))
	bdw0(2).Initialize(LoadBitmap(File.DirAssets, "btnCalcProduct0.png"))
	bdw1(2).Initialize(LoadBitmap(File.DirAssets, "btnCalcProduct1.png"))
	bdw0(3).Initialize(LoadBitmap(File.DirAssets, "btnCalcDivision0.png"))
	bdw1(3).Initialize(LoadBitmap(File.DirAssets, "btnCalcDivision1.png"))

	lblOperator.Text = OpSign(OpI)
	btnCalc(OpI).Background = bdw1(OpI)
	
	Calc.InitCurveComboBox(cbbCurve1)
	Calc.InitCurveComboBox(cbbCurve2)
	Calc.InitCurveComboBox(cbbCurve3)
'	cbbCurve1_ItemClick(OpC1, cbbCurve1.GetItem(OpC1))
'	cbbCurve2_ItemClick(OpC2, cbbCurve2.GetItem(OpC2))
'	cbbCurve3_ItemClick(OpC3, cbbCurve3.GetItem(OpC3))
	
	rbtZoomed.Text = Main.Text(231)
	rbtNotZoomed.Text = Main.Text(230)

	If Graph.Zoomed = True Then
		J0z = Graph.J0C
		J1z = Graph.J1C
		rbtZoomed.Checked = True
	Else
		If Zoomed = False Then
			J0z = 0
			J1z = Graph.CurveSampleNb
			rbtNotZoomed.Checked = True
		Else
			rbtZoomed.Checked = True
		End If
	End If
	edtJ0.Text = J0z
	edtJ1.Text = J1z

	Select OpI
	Case cCalcSum
		lblTitle.Text = Main.Text(140)
	Case cCalcDiff
		lblTitle.Text = Main.Text(137)
	Case cCalcMult
		lblTitle.Text = Main.Text(139)
	Case cCalcQuot
		lblTitle.Text = Main.Text(138)
	End Select

	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)
	IME1.Initialize("")
	
	Manage.txtDoNothing = Main.Text(234)
	
	lblHelp.Text = "Select the three curves and click on [+/-]." & CRLF & "You can change the arythmetic operation."

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub btnCalcType_Touch (Action As Int, X As Float, Y As Float)
	Dim btn As Panel
	Dim i As Int
	
	btn = Sender
	i = btn.Tag
	
	Select Action
	Case Activity.ACTION_DOWN
		btn.Background = bdw1(i)
		Select i
		Case cCalcSum
			Manage.ToolTip(lblTooltip, "Sets sum calculation")
		Case cCalcDiff
			Manage.ToolTip(lblTooltip, "Sets difference calculation")
		Case cCalcMult
			Manage.ToolTip(lblTooltip, "Sets multiplication calculation")
		Case cCalcQuot
			Manage.ToolTip(lblTooltip, "Sets division calculation")
		End Select	
	Case Activity.ACTION_MOVE
		If X > 0 AND X < btn.Width AND Y > 0 AND Y < btn.Height Then
			Select i
			Case cCalcSum
				Manage.ToolTip(lblTooltip, "Sets sum calculation")
			Case cCalcDiff
				Manage.ToolTip(lblTooltip, "Sets difference calculation")
			Case cCalcMult
				Manage.ToolTip(lblTooltip, "Sets multiplication calculation")
			Case cCalcQuot
				Manage.ToolTip(lblTooltip, "Sets division calculation")
			End Select	
		Else
			Manage.ToolTip(lblTooltip, Main.Text(234))
		End If
	Case Activity.ACTION_UP
		If X > 0 AND X < btn.Width AND Y > 0 AND Y < btn.Height Then
			btnCalc(OpI).Background = bdw0(OpI)
			OpI = btn.Tag
			btnCalc(OpI).Background = bdw1(OpI)

			lblOperator.Text = OpSign(OpI)
			
			Select OpI
			Case cCalcSum
				lblTitle.Text = Main.Text(140)
			Case cCalcDiff
				lblTitle.Text = Main.Text(137)
			Case cCalcMult
				lblTitle.Text = Main.Text(139)
			Case cCalcQuot
				lblTitle.Text = Main.Text(138)
			End Select	
		Else
			btnCalc(OpI).Background = bdw1(OpI)
			btn.Background = bdw0(i)
		End If
		Manage.ToolTip(lblTooltip, "")
	End Select
End Sub

Sub cbbCurve1_ItemClick (Position As Int, Value As Object)
	OpC1 = Position
End Sub

Sub cbbCurve2_ItemClick (Position As Int, Value As Object)
	OpC2 = Position
End Sub

Sub cbbCurve3_ItemClick (Position As Int, Value As Object)
	OpC3 = Position
End Sub

Sub rbtZoomed_CheckedChange(Checked As Boolean)
	If Checked = True Then
		edtJ0.Text = J0z
		edtJ1.Text = J1z
		Zoomed = True
	End If
End Sub

Sub rbtNotZoomed_CheckedChange(Checked As Boolean)
	If Checked = True Then
		edtJ0.Text = 0
		edtJ1.Text = Graph.CurveSampleNb
		Zoomed = False
	End If
End Sub

Sub btnCalculation_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalculation, Action, X, Y, lblTooltip, Main.Text(228), "btnCalc", "Calculation", False)
End Sub

Sub Calculation
	Dim i, i0, i1, c1, c2, c3 As Int
	
	If OpC1 = -1 OR OpC2 = -1 OR OpC3 = -1 Then
		Msgbox("You must first select the curves !", Main.Text(8)) 
		Return
	End If
	
	c1 = OpC1 + 1
	c2 = OpC2 + 1
	c3 = OpC3 + 1
	
	If rbtZoomed.Checked = True Then
		i0 = J0z
		i1 = J1z
	Else
		i0 = 0
		i1 = Graph.CurveSampleNb
	End If
	
	Select OpI
	Case cCalcSum
		For i = i0 To i1
			Graph.Curve(c3, i) = Graph.Curve(c1, i) + Graph.Curve(c2, i)
		Next
		Graph.CurveName(c3) = Graph.CurveName(c1) & " + " & Graph.CurveName(c2)
	Case cCalcDiff
		For i = i0 To i1
			Graph.Curve(c3, i) = Graph.Curve(c1, i) - Graph.Curve(c2, i)
		Next
		Graph.CurveName(c3) = Graph.CurveName(c1) & " - " & Graph.CurveName(c2)
	Case cCalcMult
		For i = i0 To i1
			Graph.Curve(c3, i) = Graph.Curve(c1, i) * Graph.Curve(c2, i)
		Next
		Graph.CurveName(c3) = Graph.CurveName(c1) & " * " & Graph.CurveName(c2)
	Case cCalcQuot
		For i = i0 To i1
			Graph.Curve(c3, i) = Graph.Curve(c1, i) / Graph.Curve(c2, i)
		Next
		Graph.CurveName(c3) = Graph.CurveName(c1) & " / " & Graph.CurveName(c2)
	End Select
	Graph.CurveUnit(c3) = Graph.CurveUnit(c1)
	Graph.CurveComm(c3) = Graph.CurveComm(c1)
	Graph.CurveCommText(c3) = Graph.CurveCommText(c1)
	Graph.CurveSpd(c3) = Graph.CurveSpd(c1)
	Graph.CurveSpdUnit(c3) = Graph.CurveSpdUnit(c1)
	Calc.UpdateCurveLists(cbbCurve1, c3, Graph.CurveName(c3), 1)
	Calc.UpdateCurveLists(cbbCurve2, c3, Graph.CurveName(c3), 1)
	Calc.UpdateCurveLists(cbbCurve3, c3, Graph.CurveName(c3), 1)
	cbbCurve3.SelectedIndex = c3 - 1
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblTooltip, Main.Text(229), "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub edtJ0_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ0, "edtJ0_ValueChanged", "Enter J0", "Int+")
	End If
End Sub

Sub edtJ0_ValueChanged(Value As Double)
	J0z = Value
End Sub

Sub edtJ1_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ1, "edtJ1_ValueChanged", "Enter J1", "Int+")
	End If
End Sub

Sub edtJ1_ValueChanged(Value As Double)
	J1z = Value
End Sub

