﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals
	Dim cGraphCalcIntegral = 0 As Int
	Dim cGraphCalcDerivative = 1 As Int
	Dim cGraphCalcOpI As Int
	Dim InitilalCondition = 0 As Double
	Dim J0z, J1z As Int
	Dim Zoomed = False As Boolean
End Sub

Sub Globals
	Dim cbbCurve1, cbbCurve2 As ComboBox
	Dim lblTitle, lblTooltip, lblInitilalCondition, lblCurveSource, lblCurveDest As Label
	Dim edtInitilalCondition As EditText
	Dim btnCalculation, btnBack As Panel
	Dim pnlInitilalCondition, pnlZoom As Panel
	Dim ic1 = -1 As Int
	Dim ic2 = -1 As Int
	Dim ToolTipText0 = "Select the two curves and click on [+-]." As String

	Dim edtJ0, edtJ1, edtDummy As EditText
	Dim rbtZoomed, rbtNotZoomed As RadioButton

	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("graphcalcintegral")
	pnlZoom.LoadLayout("zoom")
	
	ToolTipText0 = Main.Text(227)
	cbbCurve1.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbCurve1.ItemColor = Colors.RGB(255, 228, 181)
	cbbCurve1.ItemTextColor = Colors.Black
	cbbCurve1.FastScrollEnabled = True
	cbbCurve2.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbCurve2.ItemColor = Colors.RGB(255, 228, 181)
	cbbCurve2.ItemTextColor = Colors.Black
	cbbCurve2.FastScrollEnabled = True

	Calc.InitCurveComboBox(cbbCurve1)
	Calc.InitCurveComboBox(cbbCurve2)
	
	Select cGraphCalcOpI
	Case cGraphCalcIntegral
		pnlInitilalCondition.Visible = True
		lblTitle.Text = Main.Text(222) 
		lblInitilalCondition.Text = Main.Text(216) 
		lblCurveSource.Text = Main.Text(224) 
		lblCurveDest.Text = Main.Text(225) 
	Case cGraphCalcDerivative
		lblTitle.Text = Main.Text(223) 
		lblCurveSource.Text = Main.Text(226) 
		lblCurveDest.Text = Main.Text(225) 
		pnlInitilalCondition.Visible = False
	End Select
	Manage.ToolTip(lblTooltip, ToolTipText0)
	
	If Graph.Zoomed = True Then
		J0z = Graph.J0C
		J1z = Graph.J1C
		rbtZoomed.Checked = True
	Else
		If Zoomed = False Then
			J0z = 0
			J1z = Graph.CurveSampleNb
			rbtNotZoomed.Checked = True
		Else
			rbtZoomed.Checked = True
		End If
	End If
	edtJ0.Text = J0z
	edtJ1.Text = J1z
	
	rbtZoomed.Text = Main.Text(231)
	rbtNotZoomed.Text = Main.Text(230)

	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)
	IME1.Initialize("")
	
	Manage.txtDoNothing = Main.Text(234)
End Sub

Sub Activity_Resume
	edtInitilalCondition.Text = InitilalCondition
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub Calculation
	Dim I As Int
	Dim dT As Double
	Dim x1, x2, x3 As Double
	
	If ic1 = -1 OR ic2 = -1 Then
		Msgbox(Main.Text(232), Main.Text(8))
		Return
	End If
	
	dT = Graph.CurveTime(ic1)
	If dT = 0 Then
'		dT = TdTC
		dT = Graph.CurveTime(0)
	End If

	Select cGraphCalcOpI
	Case cGraphCalcIntegral
		If IsNumber(edtInitilalCondition.Text) = False Then
			Msgbox(Main.Text(217),Main.Text(8))
			edtInitilalCondition.RequestFocus
			Return
		End If
		InitilalCondition = edtInitilalCondition.Text
		Graph.Curve(ic2, J0z) = InitilalCondition
		For I = J0z + 1 To J1z - 1 Step 2
			Graph.Curve(ic2, I) = Graph.Curve(ic2, I - 1) + dT * (5 * Graph.Curve(ic1, I - 1) + 8 * Graph.Curve(ic1, I) - Graph.Curve(ic1, I + 1)) / 12
			If I <= J1z Then
				Graph.Curve(ic2, I + 1) = Graph.Curve(ic2, I - 1) + dT * (Graph.Curve(ic1, I - 1) + 4 * Graph.Curve(ic1, I) + Graph.Curve(ic1, I + 1)) / 3
			End If
		Next
		Graph.Curve(ic2, J1z) = Graph.Curve(ic2, J1z - 2) + dT * (Graph.Curve(ic1, J1z - 2) + 4 * Graph.Curve(ic1, J1z - 1) + Graph.Curve(ic1, J1z)) / 3
		Graph.CurveName(ic2) = Main.Text(55) & "  " & Graph.CurveName(ic1)
		Graph.CurveUnit(ic2) = Graph.CurveUnit(ic1).SubString2(0, Graph.CurveUnit(ic1).Length - 1) & "*s]"
		Graph.CurveTime(ic2) = Graph.CurveTime(ic1)
		Graph.CurveSpdUnit(ic2) = Graph.CurveSpdUnit(ic1)
		Graph.CurveDeg(ic2) = Graph.CurveDeg(ic1)
		Graph.CurveSpd(ic2) = Graph.CurveSpd(ic1)
		Calc.UpdateCurveLists(cbbCurve1, ic2, Graph.CurveName(ic2), 1)
		Calc.UpdateCurveLists(cbbCurve2, ic2, Graph.CurveName(ic2), 1)
		Graph.SupI = -1
		Graph.CurveI = ic2
	Case cGraphCalcDerivative
    Graph.Curve(ic2,J0z) = (Graph.Curve(ic1,J0z + 1) - Graph.Curve(ic1, J0z)) / dT
    For I = J0z + 1 To J1z - 1
      Graph.Curve(ic2, I) = (Graph.Curve(ic1, I + 1) - Graph.Curve(ic1, I - 1)) / 2 / dT
    Next
    Graph.Curve(ic2,J1z) = (Graph.Curve(ic1, J1z) - Graph.Curve(ic1, J1z - 1)) / dT
 
    x1 = Graph.Curve(ic1, J0z)
    x2 = Graph.Curve(ic1, J0z + 1)
    x3 = Graph.Curve(ic1, J0z + 2)
    Graph.Curve(ic2,J0z)=(-x3 -x1 + 2 * x2 + (x3 - x1) / 2) / dT
  
    x1 = Graph.Curve(ic1, J1z - 2)
    x2 = Graph.Curve(ic1, J1z - 1)
    x3 = Graph.Curve(ic1, J1z)
    Graph.Curve(ic2,J1z) = (x3 + x1 - 2 * x2 + (x3 - x1) / 2 ) / dT
  
		Graph.CurveName(ic2) = Main.Text(56) & "  " & Graph.CurveName(ic1)
		Graph.CurveUnit(ic2) = Graph.CurveUnit(ic1).SubString2(0, Graph.CurveUnit(ic1).Length - 1) & "/s]"
		Graph.CurveTime(ic2) = Graph.CurveTime(ic1)
		Graph.CurveSpdUnit(ic2) = Graph.CurveSpdUnit(ic1)
		Graph.CurveDeg(ic2) = Graph.CurveDeg(ic1)
		Graph.CurveSpd(ic2) = Graph.CurveSpd(ic1)
		Calc.UpdateCurveLists(cbbCurve1, ic2,Graph.CurveName(ic2), 1)
		Calc.UpdateCurveLists(cbbCurve2, ic2,Graph.CurveName(ic2), 1)
		Graph.SupI = -1
		Graph.CurveI = ic2
	End Select
End Sub

Sub cbbCurve1_ItemClick(Position As Int, Item As String)
	ic1 = Position + 1
End Sub

Sub cbbCurve2_ItemClick(Position As Int, Item As String)
	ic2 = Position + 1
End Sub

Sub btnCalculation_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalculation, Action, X, Y, lblTooltip, Main.Text(228), "btnCalc", "Calculation", True)
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblTooltip, Main.Text(228), "btnBack", "btnBackDo", True)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub edtJ0_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ0, "edtJ0_ValueChanged", "Enter J0", "Int+")
	End If
End Sub

Sub edtJ0_ValueChanged(Value As Double)
	J0z = Value
End Sub

Sub edtJ1_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ1, "edtJ1_ValueChanged", "Enter J1", "Int+")
	End If
End Sub

Sub edtJ1_ValueChanged(Value As Double)
	J1z = Value
End Sub

Sub edtInitilalCondition_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtInitilalCondition, "edtInitilalCondition_ValueChanged", "Enter Initial condition", "Dbl-")
	End If
End Sub

Sub edtInitilalCondition_ValueChanged(Value As Double)
	InitilalCondition = Value
End Sub

Sub rbtZoomed_CheckedChange(Checked As Boolean)
	If Checked = True Then
		edtJ0.Text = J0z
		edtJ1.Text = J1z
		Zoomed = True
	End If
End Sub

Sub rbtNotZoomed_CheckedChange(Checked As Boolean)
	If Checked = True Then
		edtJ0.Text = 0
		edtJ1.Text = Graph.CurveSampleNb
		Zoomed = False
	End If
End Sub