﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals
	Dim J0z, J1z As Int
	Dim Zoomed = False As Boolean
End Sub

Sub Globals
	Dim lblMean, lblCubic, lblRMS, lblMax, lblMin, lblMaxMin, lblStandardDeviation As Label
	Dim lblMean0, lblCubic0, lblRMS0, lblMax0, lblMin0, lblMaxMin0, lblStandardDeviation0 As Label
	Dim lblTitle, lblTooltip As Label
	Dim rbtZoomed, rbtNotZoomed As RadioButton
	Dim edtJ0, edtJ1, edtDummy As EditText
	Dim cbbCurves As ComboBox
	Dim btnBack, btnCurveUp, btnCurveDown As Panel
	Dim pnlZoom As Panel

	Dim MeanI = 0 		As Int
	Dim Mean = 0 			As Double
	Dim RMS = 0 			As Double
	Dim MeanCub = 0 	As Double
	Dim ValMax = 0 		As Double
	Dim ValMin = 0 		As Double
	Dim StandDev = 0 	As Double

	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("graphcalcmean")
	pnlZoom.LoadLayout("zoom")
	
	cbbCurves.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbCurves.ItemColor = Colors.RGB(255, 228, 181)
	cbbCurves.ItemTextColor = Colors.Black

	Calc.InitCurveComboBox(cbbCurves)

	If Graph.Zoomed = True Then
		J0z = Graph.J0C
		J1z = Graph.J1C
		rbtZoomed.Checked = True
	Else
		If Zoomed = False Then
			J0z = 0
			J1z = Graph.CurveSampleNb
		End If
	End If
	edtJ0.Text = J0z
	edtJ1.Text = J1z
	
	cbbCurves.SelectedIndex = Graph.CurveI - 1
	cbbCurves_ItemClick(Graph.CurveI - 1, cbbCurves.GetItem(Graph.CurveI - 1))
	cbbCurves.FastScrollEnabled = True
	
	lblTitle.Text = Main.Text(64)
	lblMean0.Text = Main.Text(65)
	lblCubic0.Text = Main.Text(66)
	rbtZoomed.Text = Main.Text(231)
	rbtNotZoomed.Text = Main.Text(230)

	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)
	IME1.Initialize("")

	Manage.txtDoNothing = Main.Text(234)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub cbbCurves_ItemClick (Position As Int, Value As Object)
	MeanI = Position + 1	
	Calculation
End Sub

Sub Calculation
	Dim i, n, k, i0, i1 As Int
	
	If rbtZoomed.Checked = True Then
		i0 = J0z
		i1 = J1z
	Else
		i0 = 0
		i1 = Graph.CurveSampleNb
	End If
	
	n = i1 - i0 + 1
	Mean = 0
	RMS = 0
	MeanCub = 0
	ValMax = 0
	ValMin = 0
	StandDev = 0

	For i = i0 To i1
		Mean = Mean + Graph.Curve(MeanI, i)
		RMS = RMS + Graph.Curve(MeanI,i) * Graph.Curve(MeanI, i)
		MeanCub = MeanCub + Power(Graph.Curve(MeanI, i), 3)
		ValMax = Max(ValMax, Graph.Curve(MeanI,i))
		ValMin = Min(ValMin, Graph.Curve(MeanI,i))
	Next
	StandDev = Sqrt((RMS - Mean * Mean / n) / (n - 1))
	Mean = Mean / n
	RMS = Sqrt(RMS / n)
	k = Abs(MeanCub) / MeanCub
	MeanCub = Power(Abs(MeanCub / n), 1 / 3) * k
	lblMean.Text = " " & Mean
	lblRMS.Text = " " & RMS
	lblCubic.Text = " " & MeanCub
	lblMax.Text = " " & ValMax
	lblMin.Text = " " & ValMin
	lblMaxMin.Text = " " & (ValMax - ValMin)
	lblStandardDeviation.Text = " " & StandDev
End Sub

Sub btnBack_Touch(Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblTooltip, "Go back to the Graphics window", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub btnCurveUp_Touch(Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCurveUp, Action, X, Y, lblTooltip, "Previous curve", "btnArrowUpSmall", "btnCurveUpDo", False)
End Sub

Sub btnCurveUpDo
	If cbbCurves.SelectedIndex > 0 Then
		cbbCurves.SelectedIndex = cbbCurves.SelectedIndex - 1
		cbbCurves_ItemClick(cbbCurves.SelectedIndex, cbbCurves.GetItem(cbbCurves.SelectedIndex))
	End If
End Sub

Sub btnCurveDown_Touch(Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCurveDown, Action, X, Y, lblTooltip, "Next curve", "btnArrowDownSmall", "btnCurveDownDo", False)
End Sub

Sub btnCurveDownDo
	If cbbCurves.SelectedIndex < Graph.CurveNb - 1 Then
		cbbCurves.SelectedIndex = cbbCurves.SelectedIndex + 1
		cbbCurves_ItemClick(cbbCurves.SelectedIndex, cbbCurves.GetItem(cbbCurves.SelectedIndex))
	End If
End Sub

Sub edtJ0_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ0, "edtJ0_ValueChanged", "Enter J0", "Int+")
	End If
End Sub

Sub edtJ0_ValueChanged(Value As Double)
	J0z = Value
End Sub

Sub edtJ1_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ1, "edtJ1_ValueChanged", "Enter J1", "Int+")
	End If
End Sub

Sub edtJ1_ValueChanged(Value As Double)
	J1z = Value
End Sub

Sub rbtZoomed_CheckedChange(Checked As Boolean)
	If Checked = True Then
		edtJ0.Text = J0z
		edtJ1.Text = J1z
		Zoomed = True
	End If
End Sub

Sub rbtNotZoomed_CheckedChange(Checked As Boolean)
	If Checked = True Then
		edtJ0.Text = 0
		edtJ1.Text = Graph.CurveSampleNb
		Zoomed = False
	End If
End Sub

