﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals
	Dim Offset = 0 As Double
	Dim OldOffset = 0 As Double
	Dim Gain = 1 As Double
	Dim OldGain = 1 As Double
	Dim J0z, J1z As Int
	Dim Zoomed = False As Boolean
End Sub

Sub Globals
	Dim lblOldValue0, lblNewValue, lblOldValue, lblTooltip, lblTitle As Label
	Dim pnlZoom, btnCalc, btnOldValue, btnBack As Panel
	Dim ltbCurves As ListBox
	Dim edtNewValue, edtJ0, edtJ1, edtDummy As EditText
	Dim rbtZoomed, rbtNotZoomed As RadioButton

	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("graphcalcoffset")
	pnlZoom.LoadLayout("zoom")
	
	Code.SetPadding(lblOldValue)
	
	Calc.InitCurveListBox(ltbCurves)

	If Graph.Zoomed = True Then
		J0z = Graph.J0C
		J1z = Graph.J1C
		rbtZoomed.Checked = True
	Else
		If Zoomed = False Then
			J0z = 0
			J1z = Graph.CurveSampleNb
			rbtNotZoomed.Checked = True
		Else
			rbtZoomed.Checked = True
		End If
	End If
	edtJ0.Text = J0z
	edtJ1.Text = J1z
	
	ltbCurves.ItemColor = Colors.RGB(255, 228, 181)
	ltbCurves.BackgroundColor = Colors.RGB(165, 42, 42)
	ltbCurves.TextSize = 16
	ltbCurves.TextColor = Colors.Black
	ltbCurves.ItemHeight = 40dip
	ltbCurves.MultiSelect = True
	ltbCurves.MultiSelectListClear
'	ltbCurves.MultiSelectList.Add(graph.CurveI - 1)
	ltbCurves.SelectedIndex = Graph.CurveI - 1
	ltbCurves.FastScrollEnabled = True
	
	Select Graph.FlagGraphCalc
	Case Graph.cOffset
		lblTitle.Text = Main.Text(53)
		lblOldValue.Text =  OldOffset
		edtNewValue.Text = 0
	Case Graph.cGain
		lblTitle.Text = Main.Text(54)
		lblOldValue.Text =  OldGain
		edtNewValue.Text = 1
	End Select
	
	lblOldValue0.Text = Main.Text(60)
	lblNewValue.Text = Main.Text(61)
	rbtZoomed.Text = Main.Text(231)
	rbtNotZoomed.Text = Main.Text(230)

	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)
	IME1.Initialize("")
	
	Manage.txtDoNothing = Main.Text(234)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub btnCalc_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCalc, Action, X, Y, lblTooltip, "Calculate the result", "btnCalc", "Calculation", False)
End Sub

Sub Calculation
	Dim c, i, i0, i1, j As Int
	
	If rbtZoomed.Checked = True Then
		i0 = J0z
		i1 = J1z
	Else
		i0 = 0
		i1 = Graph.CurveSampleNb
	End If

	Select Graph.FlagGraphCalc
	Case Graph.cOffset
		Offset = edtNewValue.Text
		For j = 0 To ltbCurves.MultiSelectList.Size - 1
			c = ltbCurves.MultiSelectList.Get(j) + 1
			For i = i0 To i1
				Graph.Curve(c, i) = Graph.Curve(c, i) + Offset
			Next
		Next
		OldOffset = Offset
	Case Graph.cGain
		Gain = edtNewValue.Text
		For j = 0 To ltbCurves.MultiSelectList.Size - 1
			c = ltbCurves.MultiSelectList.Get(j) + 1
			For i = i0 To i1
				Graph.Curve(c, i) = Graph.Curve(c, i) * Gain
			Next
		Next
		OldGain = Gain
	End Select
	ToastMessageShow("Calculation complete", False)
End Sub

Sub btnOldValue_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnOldValue, Action, X, Y, lblTooltip, "Gets the last value used", "btnMoveDownLeft", "btnOldValueDo", False)
End Sub

Sub btnOldValueDo
	Select Graph.FlagGraphCalc
	Case Graph.cOffset
		edtNewValue.Text = -OldOffset
	Case Graph.cGain
		edtNewValue.Text = 1 / OldGain
	End Select		
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblTooltip, "Goes back to the Graphics window", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish	
End Sub

Sub rbtZoomed_CheckedChange(Checked As Boolean)
	If Checked = True Then
		edtJ0.Text = J0z
		edtJ1.Text = J1z
		Zoomed = True
	End If
End Sub

Sub rbtNotZoomed_CheckedChange(Checked As Boolean)
	If Checked = True Then
		edtJ0.Text = 0
		edtJ1.Text = Graph.CurveSampleNb
		Zoomed = False
	End If
End Sub

Sub edtNewValue_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtNewValue, "edtNewValue_ValueChanged", "Enter new value", "Dbl-")
	End If
End Sub

Sub edtNewValue_ValueChanged(Value As Double)
	
End Sub

Sub edtJ0_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ0, "edtJ0_ValueChanged", "Enter J0", "Int+")
	End If
End Sub

Sub edtJ0_ValueChanged(Value As Double)
	J0z = Value
End Sub

Sub edtJ1_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ1, "edtJ1_ValueChanged", "Enter J1", "Int+")
	End If
End Sub

Sub edtJ1_ValueChanged(Value As Double)
	J1z = Value
End Sub
