﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim ltbCurves As ListBox
	Dim btnOK, btnBack As Panel
	Dim lblTitle, lblToolTip As Label
	
	Dim CopyMode = 0 As Int
	Dim CurvesToCopy() As Int
	Dim CurvesCopyAt As Int
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("GraphCopyCurves")
	
	Calc.InitCurveListBox(ltbCurves)
	ltbCurves.ItemColor = Colors.RGB(255, 228, 181)
	ltbCurves.BackgroundColor = Colors.RGB(165, 42, 42)
	ltbCurves.TextSize = 16
	ltbCurves.TextColor = Colors.Black
	ltbCurves.ItemHeight = 40dip
	ltbCurves.MultiSelect = True
	ltbCurves.FastScrollEnabled = True
	
	Manage.txtPermanentToolTip = "Select the curves to copy and click OK."
	Manage.ToolTip(lblToolTip, Manage.txtPermanentToolTip)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Manage.ToolTip(lblToolTip, "")
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Goes back to the Graph window", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub btnOK_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnOK, Action, X, Y, lblToolTip, "Select the curves to copy and click OK", "btnOK", "btnOKDo", True)
End Sub

Sub btnOKDo
	Dim i, j, js, jd As Int
	
	Select CopyMode
	Case 0
		Dim CurvesToCopy(ltbCurves.MultiSelectList.Size) As Int
		
		For i = 0 To ltbCurves.MultiSelectList.Size - 1
			CurvesToCopy(i) = ltbCurves.MultiSelectList.Get(i) + 1
		Next
		CopyMode = 1
		Manage.txtPermanentToolTip = "Select the curve from where copy the curves and click OK."
		ltbCurves.MultiSelectListClear
		ltbCurves.MultiSelect = False
	Case 1
		CurvesCopyAt = ltbCurves.SelectedIndex + 1
		For j = 0 To CurvesToCopy.Length - 1
			js = CurvesToCopy(j)
			jd = CurvesCopyAt + j
			For i = 0 To Graph.CurveSampleNb
				Graph.Curve(jd, i) = Graph.Curve(js, i)
			Next
			Graph.CurveName(jd) = Graph.CurveName(js)
			Graph.CurveUnit(jd) = Graph.CurveUnit(js)
			Graph.CurveComm(jd) = Graph.CurveComm(js)
			Graph.CurveCommText(jd) = Graph.CurveCommText(js)
			Graph.CurveSpd(jd) = Graph.CurveSpd(js)
			Graph.CurveSpdUnit(jd) = Graph.CurveSpdUnit(js)
			Calc.UpdateCurveLists(ltbCurves, jd, Graph.CurveName(js), 1)
		Next
		ltbCurves.SelectedIndex = -1
		ltbCurves.MultiSelect = True
		CopyMode = 0
		Manage.txtPermanentToolTip = "Select the curves to copy and click OK."
		Manage.ToolTip(lblToolTip, Manage.txtPermanentToolTip)
	End Select
End Sub

