﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals
	Dim flgShowValues = True As Boolean
End Sub

Sub Globals
	Dim btnBack, btnOK, btnMultiselect As Panel
	Dim btnSetSameValue, btnLinearInterpolation, btnCosineInterpolation As Panel
	Dim pnlToolBox1 As Panel
	Dim lblToolTip As Label
	Dim cbbCurves As ComboBox
	Dim ltbSampleValues As ListBox
	Dim cbxShowValues As CheckBox
	Dim edtNewName, edtNewUnit, edtNewComment, edtNewCommentText, edtDummy As EditText
	Dim edtNewValue, edtNewSpeed, edtNewDeltaTime, edtNewDeltaDegree As EditText
	Dim lblNewName, lblNewUnit, lblNewComment, lblNewCommentText As Label
	Dim lblNewValue, lblNewSpeed, lblNewDeltaTime, lblNewDeltaDegree As Label
	
	Dim CurveIndex As Int
	Dim flgMultiSelect = False As Boolean
	Dim MultiSelectItem1, MultiSelectItem2 As Int
	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("GraphEditCurve")
	
	ltbSampleValues.MultiSelect = True
	ltbSampleValues.ItemColor = Colors.White
	ltbSampleValues.BackgroundColor = Colors.Black
	ltbSampleValues.ItemHeight = 36dip
	ltbSampleValues.FastScrollEnabled = True
	
	cbbCurves.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbCurves.ItemColor = Colors.RGB(255, 228, 181)
	cbbCurves.TextColor = Colors.Black
	cbbCurves.NumberVisibleItems = 15
	cbbCurves.FastScrollEnabled = True
	FillComboBox
	
	If Graph.SupI = -1 Then
		cbbCurves_ItemClick(Graph.CurveI - 1, Graph.CurveName(Graph.CurveI))
		cbbCurves.SelectedIndex = Graph.CurveI - 1
	Else
		cbbCurves_ItemClick(Graph.SupIN(0) - 1, Graph.CurveName(Graph.SupIN(0)))
		cbbCurves.SelectedIndex = Graph.SupIN(0) - 1
	End If

	If flgShowValues = True Then
		FillListBox
	Else
	End If
	ltbSampleValues.Visible = flgShowValues
	cbxShowValues.Checked = flgShowValues
	
	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)	
	IME1.Initialize("")

	Manage.txtDoNothing = Main.Text(234)
End Sub

Sub Activity_Resume
	UpdateCurveParameters
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Returns to Graph srceen", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub btnOK_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnOK, Action, X, Y, lblToolTip, "Updates the selected curve with the new parameters", "btnOK", "btnOKDo", False)
End Sub

Sub btnOKDo
	SetCurveParameters
End Sub

Sub btnMultiselect_Touch (Action As Int, X As Float, Y As Float)
	Manage.txtPermanentToolTip = "Select the first sample for interpolation"
	Manage.ToggleButtonClick(Me, btnMultiselect, Action, X, Y, lblToolTip, "Activate interpolation between two samples", "Release interpolation","btnLinearInterpolation", "btnMultiselectDoOn", "btnMultiselectDoOff", True)
End Sub

Sub btnMultiselectDoOn
	flgMultiSelect = True
	Select ltbSampleValues.MultiSelectList.Size 
	Case 0
		ToolTip("Select the first sample for interpolation")
	Case 1
		ToolTip("Select the second sample for interpolation")
	Case 2
		ToolTip("Select the interpolation function (enter the new value for same values)")
		pnlToolBox1.Visible = True
		MultiSelectItem1 = ltbSampleValues.MultiSelectList.Get(0)
		MultiSelectItem2 = ltbSampleValues.MultiSelectList.Get(1)
		If MultiSelectItem1 > MultiSelectItem2 Then
			MultiSelectItem1 = ltbSampleValues.MultiSelectList.Get(1)
			MultiSelectItem2 = ltbSampleValues.MultiSelectList.Get(0)
		End If
	Case Else
		ltbSampleValues.MultiSelectListClear
	End Select
End Sub

Sub btnMultiselectDoOff
	flgMultiSelect = False
	pnlToolBox1.Visible = False
'	ltbSampleValues.MultiSelectListClear
End Sub

Sub btnSetSameValue_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnSetSameValue, Action, X, Y, lblToolTip, "Sets the same value between the two samples", "btnSetSameValue", "btnSetSameValueDo", False)
End Sub

Sub btnSetSameValueDo
	Dim i As Int
	
	If edtNewValue.Text = "" Then
		ToolTip("Please enter a value in 'New value'")
	Else
		For i = MultiSelectItem1 To MultiSelectItem2
			Graph.Curve(CurveIndex, i) = edtNewValue.Text
			ltbSampleValues.SetItem(i, i & ": " & Graph.Curve(CurveIndex, i))
		Next
	End If
	btnMultiselect_Touch(Activity.ACTION_DOWN, 1, 1)
	ltbSampleValues.MultiSelectListClear
	edtNewValue.Text = ""
End Sub

Sub btnLinearInterpolation_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnLinearInterpolation, Action, X, Y, lblToolTip, "Interpolates the values between the two samples with a linear function", "btnLinearInterpolation", "btnLinearInterpolationDo", False)
End Sub

Sub btnLinearInterpolationDo
	Dim i, j As Int
	Dim delta As Double
	
	delta = (Graph.Curve(CurveIndex, MultiSelectItem2) - Graph.Curve(CurveIndex, MultiSelectItem1)) / (MultiSelectItem2 - MultiSelectItem1)
	For i = MultiSelectItem1 To MultiSelectItem2
		j = i - MultiSelectItem1
		Graph.Curve(CurveIndex, i) = Graph.Curve(CurveIndex, MultiSelectItem1) + j * delta
		ltbSampleValues.SetItem(i, i & ": " & Graph.Curve(CurveIndex, i))
	Next
	btnMultiselect_Touch(Activity.ACTION_UP, 1, 1)
	ltbSampleValues.MultiSelectListClear
	edtNewValue.Text = ""
End Sub

Sub btnCosineInterpolation_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnCosineInterpolation, Action, X, Y, lblToolTip, "Interpolates the values between the two samples with a cosine function", "btnCosineInterpolation", "btnCosineInterpolationDo", False)
End Sub

Sub btnCosineInterpolationDo
	Dim i, j As Int
	Dim ampl, omega As Double
	
	ampl = (Graph.Curve(CurveIndex, MultiSelectItem2) - Graph.Curve(CurveIndex, MultiSelectItem1)) / 2
	omega = cPI / (MultiSelectItem2 - MultiSelectItem1)
	For i = MultiSelectItem1 To MultiSelectItem2
		j = i - MultiSelectItem1
		Graph.Curve(CurveIndex, i) = Graph.Curve(CurveIndex, MultiSelectItem1) - ampl * (Cos(omega * j) - 1)
		ltbSampleValues.SetItem(i, i & ": " & Graph.Curve(CurveIndex, i))
	Next
	btnMultiselect_Touch(Activity.ACTION_DOWN, 1, 1)
	ltbSampleValues.MultiSelectListClear
	edtNewValue.Text = ""
End Sub

Sub cbbCurves_ItemClick(Position As Int, Item As String)
	CurveIndex = Position + 1
	UpdateCurveParameters
	If flgShowValues = True Then
		FillListBox
	End If
End Sub

Sub FillComboBox
	Dim i As Int
	
	cbbCurves.Clear
	For i = 1 To Graph.CurveNb - 1
		cbbCurves.Add(i & ": " & Graph.CurveName(i))
	Next 
End Sub

Sub FillListBox
	Dim i As Int
	
	ltbSampleValues.Clear
	For i = 0 To Graph.CurveSampleNb - 1
		ltbSampleValues.AddItem(i & ": " & Graph.Curve(CurveIndex, i))
	Next
End Sub

Sub edtNewValue_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtNewValue, "edtKp_ValueChanged", "Enter Dd", "Dbl+")
	End If
End Sub

Sub cbxShowValues_CheckedChange(Checked As Boolean)
	flgShowValues = Checked
	ltbSampleValues.Visible = flgShowValues
	
	If flgShowValues = True Then
		FillListBox
	Else
'		cbbCurves.Clear
	End If
End Sub

Sub ltbSampleValues_ItemClick(Position As Int, Item As String)
	If flgMultiSelect = True Then
		If ltbSampleValues.MultiSelectList.Size = 0 Then
			ToolTip("Select the first sample for interpolation")
		Else If ltbSampleValues.MultiSelectList.Size = 1 Then
			ToolTip("Select the second sample for interpolation")
		Else
			ToolTip("Select the interpolation function (enter the new value for same values)")
			pnlToolBox1.Visible = True
			MultiSelectItem1 = ltbSampleValues.MultiSelectList.Get(0)
			MultiSelectItem2 = ltbSampleValues.MultiSelectList.Get(1)
			If MultiSelectItem1 > MultiSelectItem2 Then
				MultiSelectItem1 = ltbSampleValues.MultiSelectList.Get(1)
				MultiSelectItem2 = ltbSampleValues.MultiSelectList.Get(0)
			End If
		End If
	End If
	
	If ltbSampleValues.MultiSelectList.Size > 0 Then
		edtNewValue.Text = Graph.Curve(CurveIndex, ltbSampleValues.MultiSelectList.Get(ltbSampleValues.MultiSelectList.Size - 1))
	End If
End Sub

Sub UpdateCurveParameters
	edtNewName.Text = Graph.CurveName(CurveIndex)
	edtNewUnit.Text = Graph.CurveUnit(CurveIndex)
	edtNewComment.Text = Graph.CurveComm(CurveIndex)
	edtNewCommentText.Text = Graph.CurveCommText(CurveIndex)
	If ltbSampleValues.MultiSelectList.Size > 0 Then
		edtNewValue.Text = Graph.Curve(CurveIndex, ltbSampleValues.MultiSelectList.Get(ltbSampleValues.MultiSelectList.Size - 1))
	Else
		edtNewValue.Text = ""
	End If
	edtNewSpeed.Text = Graph.CurveSpd(CurveIndex)
	edtNewDeltaTime.Text = Graph.CurveTime(CurveIndex)
	edtNewDeltaDegree.Text = Graph.CurveDeg(CurveIndex)
End Sub

Sub SetCurveParameters
	Dim i, k As Int
	
	Graph.CurveName(CurveIndex) = edtNewName.Text
	Graph.CurveUnit(CurveIndex) = edtNewUnit.Text
	Graph.CurveComm(CurveIndex) = edtNewComment.Text
	Graph.CurveCommText(CurveIndex) = edtNewCommentText.Text
	Graph.CurveSpd(CurveIndex) = edtNewSpeed.Text
	Graph.CurveTime(CurveIndex) = edtNewDeltaTime.Text
	Graph.CurveDeg(CurveIndex) = edtNewDeltaDegree.Text
	
	For i = 0 To ltbSampleValues.MultiSelectList.Size - 1
		k = ltbSampleValues.MultiSelectList.Get(i)
		Graph.Curve(CurveIndex, k) = edtNewValue.Text
		ltbSampleValues.SetItem(k, "k:" & edtNewValue.Text)
	Next
End Sub

Sub ToolTip(txt As String)
	lblToolTip.Text = txt
	If txt = "" Then
		lblToolTip.Visible = False
	Else
		lblToolTip.Visible = True
	End If
End Sub

