﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals
	Dim flgCurvesAtInitialPosition = True As Boolean
	Dim flgDynSimFileType = True As Boolean
	Dim flgFileType = "dsc" As String
End Sub

Sub Globals
	Dim btnBack, btnLoad, btnDeleteFile As Panel
	Dim pnlCheckCurves As Panel
	Dim btnSelectAll, btnUnselectAll As Button
	Dim lblToolTip, lblFileName0, lblFileName, lblComment0, lblComment, lblHelp As Label
	Dim rbtCurvesAtInitialPosition, rbtCurvesAtNewPosition, rbtDynSimFileType, rbtExcelFileType As RadioButton
	Dim ckbWithSetup As CheckBox
	Dim ltbFileNames As ListBox
	Dim edtIndexNewPosition, edtDummy As EditText
	
	Dim CurveFile As String
	Dim LC_CurveNb, LC_CurveI()  As Int
	Dim LC_Setup As Boolean
	Dim lstFileNames As List

	Dim LC_CurveI0 = 0 As Int
	Dim LC_Comment = "" As String
	
	Dim LC_Setup = True As Boolean
	Dim LC_Setup0 = True As Boolean
	
	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("GraphLoadCurves")
	
	UpdateLanguage
	InitCurvePanel
	Code.SetPadding(lblFileName)
	Code.SetPadding(lblComment)

	ltbFileNames.ItemColor = Colors.RGB(255, 228, 181)
	ltbFileNames.BackgroundColor = Colors.RGB(165, 42, 42)
	ltbFileNames.MultiSelect = False
	ltbFileNames.TextSize = 16
	ltbFileNames.TextColor = Colors.Black
	ltbFileNames.ItemHeight = 40dip
	ltbFileNames.FastScrollEnabled = True

	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)
	IME1.Initialize("")

	Manage.txtDoNothing = Main.Text(234)
End Sub

Sub Activity_Resume
	rbtCurvesAtInitialPosition.Checked = flgCurvesAtInitialPosition
	rbtDynSimFileType.Checked = flgDynSimFileType
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Returns to Graph srceen", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub btnLoad_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnLoad, Action, X, Y, lblToolTip, "Loads the selected curves from the selected file.", "btnLoad", "btnLoadDo", False)
End Sub

Sub btnLoadDo
	If CurveFile.EndsWith("dsc") Then	
		LoadCurvesCrv
	Else
'		LoadCurvesCsv
		Graph.SupI = -1
		Graph.CurveI = 2
	End If
End Sub

Sub btnDeleteFile_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnDeleteFile, Action, X, Y, lblToolTip, "Deletes the selected file.", "btnDelete", "btnDeleteFileDo", False)
End Sub

Sub btnDeleteFileDo
	Dim Answ As Int
	
	Answ = Msgbox2("Do you really want to delete " & CRLF & CurveFile & " ?", "A T T E N T I O N", "Yes", "", "No", Null)
	
	If Answ = DialogResponse.POSITIVE Then
		File.Delete(Main.DefaultDir, CurveFile)
	End If
End Sub

Sub btnSelectAll_Click
	Dim i As Int
	
	For i = 0 To LC_CurveNb - 1
		GetCheckBox(LC_CurveI(i)).Checked = True
	Next
End Sub

Sub btnUnselectAll_Click
	Dim i As Int
	
	For i = 0 To LC_CurveNb - 1
		GetCheckBox(LC_CurveI(i)).Checked = False
	Next
End Sub

Sub rbtCurvesAtInitialPosition_CheckedChange(Checked As Boolean)
	If Checked = True Then
		flgCurvesAtInitialPosition = True
		edtIndexNewPosition.Visible = False
	End If
End Sub

Sub rbtCurvesAtNewPosition_CheckedChange(Checked As Boolean)
	If Checked = True Then
		flgCurvesAtInitialPosition = False
		edtIndexNewPosition.Visible = True
	End If
End Sub

Sub rbtDynSimFileType_CheckedChange(Checked As Boolean)
	flgFileType = "dsc"
	FillListBox
End Sub

Sub rbtExcelFileType_CheckedChange(Checked As Boolean)
	flgFileType = "csv"
	FillListBox
End Sub

Sub GetCheckBox(Index As Int) As CheckBox
	Dim ckb As CheckBox
	ckb = pnlCheckCurves.GetView(Index)
	Return ckb
End Sub

Sub ltbFileNames_ItemClick (Position As Int, Value As Object)
	CurveFile = Value
	LoadCurvesInit
End Sub

Sub edtIndexNewPosition_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtIndexNewPosition, "edtIndexNewPosition_ValueChanged", "Enter index for the first position", "Int+")
	End If
End Sub

Sub edtIndexNewPosition_ValueChanged(Value As Double)
	LC_CurveI0 = Value
End Sub

Sub LoadCurvesInit
	Dim tr As TextReader
	Dim i, k , nn As Int
	Dim v, v0 As String
	Dim txt As String
	Dim Rep As Int
	
	For i = 0 To Graph.CurveNb - 1
		Dim ckb = GetCheckBox(i) As CheckBox
		ckb.Enabled = False
		ckb.Checked = False
		ckb.TextColor = Colors.Gray
		ckb.Typeface = Typeface.DEFAULT
	Next
	lblComment.Text = ""
	lblFileName.Text = ""
	
	If CurveFile = "" Then
		Return
	End If
	
	tr.Initialize(File.OpenInput(Main.DefaultDir, CurveFile))
	
	v0 = tr.ReadLine  ' version
	v = v0.SubString2(0, 6)
	If v <> "DynSim" Then
		Msgbox(Main.Text(99),Main.Text(8))
		Return
	End If 
	
	v = v0.SubString(6)
	
	lblFileName.Text = CurveFile
	
	nn = tr.ReadLine
	If nn <> Graph.CurveSampleNb Then
		txt = Main.Text(100)&CRLF
		txt = txt & nn & " " & Main.Text(101) & " " & Graph.CurveSampleNb & " " & Main.Text(102) & CRLF & CRLF
		txt = txt & Main.Text(103)
		Rep = Msgbox2(txt,Main.Text(8),"Yes", "", "No", Null)
		If Rep = DialogResponse.NEGATIVE Then
			tr.Close
			Return
		Else
			Graph.CurveSampleNb = nn
		End If
	End If
	LC_Comment = tr.ReadLine
	lblComment.Text = LC_Comment
	LC_Setup0 = tr.ReadLine
	LC_CurveNb = tr.ReadLine
	Dim LC_CurveI(LC_CurveNb) As Int
	For i = 0 To LC_CurveNb - 1
		LC_CurveI(i) = tr.ReadLine
		k = LC_CurveI(i) - 1
		Dim ckb = GetCheckBox(k) As CheckBox
		ckb.Enabled = True
		ckb.Checked = True
		ckb.TextColor = Colors.RGB(165, 42, 42)
		ckb.Typeface = Typeface.DEFAULT_BOLD
	Next	
	tr.Close
	lblComment.Text = LC_Comment
	lblFileName.Text = CurveFile
	pnlCheckCurves.Visible = True

End Sub

Sub LoadCurvesCrv
	Dim tr As TextReader
	Dim i, j, k, nn As Int
	Dim v0, v, txt As String
	Dim Rep As Int
	Dim Dummy As String
	tr.Initialize(File.OpenInput(Main.DefaultDir, CurveFile))
	
	v0 = tr.ReadLine  ' version
	v = v0.SubString2(0, 6)
	If v <> "DynSim" Then
		Msgbox(Main.Text(99),Main.Text(8))
		Return
	End If 
	
	v = v0.SubString2(6, 9)
	
	nn = tr.ReadLine
	If nn <> Graph.CurveSampleNb Then
		txt = Main.Text(100)& CRLF
		txt = txt & nn & " " & Main.Text(101) & " " & Graph.CurveSampleNb & " " & Main.Text(102) & CRLF & CRLF
		txt = txt & Main.Text(103)
		Rep = Msgbox2(txt, Main.Text(8), "Yes", "", "No", Null)
		If Rep = DialogResponse.NEGATIVE Then
			tr.Close
			Return
		Else
			Graph.CurveSampleNb = nn
		End If
	End If
	LC_Comment = tr.ReadLine
	LC_Setup0 = tr.ReadLine
	LC_CurveNb = tr.ReadLine
	Dim LC_CurveI(LC_CurveNb) As Int
	For i = 0 To LC_CurveNb - 1
		LC_CurveI(i) = tr.ReadLine
	Next

	k = LC_CurveI0 - 1
	For i = 0 To LC_CurveNb - 1
		If GetCheckBox(LC_CurveI(i) - 1).Checked Then
			If flgCurvesAtInitialPosition = True Then
				k = LC_CurveI(i)
			Else
				k = k + 1
			End If
			Graph.CurveName(k) = tr.ReadLine
			Graph.CurveUnit(k) = tr.ReadLine
			Graph.CurveTime(k) = tr.ReadLine
			Graph.CurveDeg(k) = tr.ReadLine
			Graph.CurveSpd(k) = tr.ReadLine
			Graph.CurveSpdUnit(k) = tr.ReadLine
		
			Graph.CurveMax(k) = tr.ReadLine
			Graph.CurveMin(k) = tr.ReadLine
			Graph.CurveMaxMin(k) = Graph.CurveMax(k) - Graph.CurveMin(k)
			Graph.CurveComm(k) = tr.ReadLine
			Graph.CurveCommText(k) = tr.ReadLine
			Graph.CurveCol(k) = tr.ReadLine
			Graph.CurveScMaxA(k) = tr.ReadLine
			Graph.CurveScMinA(k) = tr.ReadLine
			Graph.CurveScDA(k) = tr.ReadLine
			Graph.CurveScMaxM(k) = tr.ReadLine
			Graph.CurveScMinM(k) = tr.ReadLine
			Graph.CurveScDM(k) = tr.ReadLine
		
			For j = 0 To Graph.CurveSampleNb
				Graph.Curve(k,j) = tr.ReadLine
			Next 
		Else
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			Dummy = tr.ReadLine
			For j = 0 To Graph.CurveSampleNb
				Dummy = tr.ReadLine
			Next 
		End If
	Next 

	If LC_Setup = True AND LC_Setup0 = True Then
		LoadCurvesSetup(tr)
	End If
	
	tr.Close
End Sub

Sub LoadCurvesSetup(tr As TextReader)
	Dim I As Int
	
	Graph.J0C = tr.ReadLine
	Graph.J1C = tr.ReadLine
	Graph.J0z = tr.ReadLine
	Graph.J1z = tr.ReadLine
	Graph.CurveAbscissaType = tr.ReadLine
	Main.TdtC = tr.ReadLine
	Main.TddC = tr.ReadLine
	Graph.CurveTime(0) = Main.TdtC
	Graph.CurveDeg(0) = Main.TddC

	Graph.CurveDispNumbers = tr.ReadLine
	Graph.CurveDispUnits = tr.ReadLine
	Graph.CurveDispSpeed = tr.ReadLine
	Graph.CurveDispComm = tr.ReadLine
	Graph.CurveDispCommText = tr.ReadLine
	
	Graph.CurveStep = tr.ReadLine
	Graph.DrawBitmapFrame = tr.ReadLine
	Graph.DrawBitmapColor = tr.ReadLine
	Graph.DrawBitmapPreview = tr.ReadLine
	Graph.DrawGridSizeI = tr.ReadLine

	For I = 0 To 3
		Graph.ColCurve(I) = tr.ReadLine
		Graph.WidthCurve(I) = tr.ReadLine
	Next

	Graph.SupNb = tr.ReadLine
	Graph.SupI = tr.ReadLine
	For I = 0 To Graph.SupNb - 1
		Graph.SupIN(I) = tr.ReadLine
		For j = 0 To Graph.SupIN(I) - 1
			Graph.SupIJ(I,j) = tr.ReadLine
		Next
	Next
End Sub

Sub InitCurvePanel
	Dim x0 = 10dip As Int
	Dim w = 70dip As Int
	Dim xstep  = 80dip As Int
	Dim y0 = 10dip As Int
	Dim h = 30dip As Int
	Dim ystep  = 35dip As Int

	Dim col, row, i As Int
	For row = 0 To 9
		For col = 0 To 9
			Dim ckb As CheckBox
			ckb.Initialize("ckbCurves")
			i = col + 10 * row + 1
			ckb.Text = i
			ckb.Tag = i
			ckb.TextSize = 18
			ckb.TextColor = Colors.RGB(165, 42, 42)
			pnlCheckCurves.AddView(ckb, x0 + xstep * col, y0 + ystep * row, w, h)
		Next
	Next
End Sub

Sub FillListBox
	Dim i As Int
	Dim name As String
	
	ltbFileNames.MinSelections = 1
	lstFileNames = File.ListFiles(Main.DefaultDir)
	lstFileNames.Sort(True)
	ltbFileNames.Clear
	For i = 0 To lstFileNames.Size - 1
		name = lstFileNames.Get(i)
		If name.EndsWith(flgFileType) Then
			ltbFileNames.AddItem(lstFileNames.Get(i))
		End If
	Next

	If ltbFileNames.Size > 0 Then
		CurveFile = ltbFileNames.GetItem(0)
		ltbFileNames_ItemClick(0, CurveFile)
		ltbFileNames.SelectedIndex = 0
	Else
		CurveFile = ""
	End If
	LoadCurvesInit
End Sub

Sub UpdateLanguage
	lblHelp.Text = "Select the file to load in the list below." & CRLF
	lblHelp.Text = lblHelp.Text & "Below you find the indexes of the curves in the file."  & CRLF 
	lblHelp.Text = lblHelp.Text & "Select the curves you want to load and click on the Load button."
End Sub
