﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim btnBack, btnSave As Panel
	Dim lblTitle, lblToolTip, lblHelp As Label
	Dim ltbCurves, ltbFileNames As ListBox
	Dim ckbWithSetup As CheckBox
	Dim tw As TextWriter
	Dim edtComment, edtFileName As EditText
	Dim rbtDynSim, rbtCsv As RadioButton
	
	Dim GC_CurveNb As Int
	Dim GC_CurveI As List
	Dim GC_SaveSetup = True As Boolean
	Dim CurveFile As String
	Dim FileExtension = ".dsc" As String
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("GraphSaveCurves")
	ltbCurves.ItemColor = Colors.RGB(255, 228, 181)
	ltbCurves.BackgroundColor = Colors.RGB(165, 42, 42)
	ltbCurves.MultiSelect = True
	ltbCurves.TextSize = 16
	ltbCurves.TextColor = Colors.Black
	ltbCurves.ItemHeight = 40dip
	ltbCurves.FastScrollEnabled = True

	ltbFileNames.ItemColor = Colors.RGB(255, 228, 181)
	ltbFileNames.BackgroundColor = Colors.RGB(165, 42, 42)
	ltbFileNames.MultiSelect = False
	ltbFileNames.TextSize = 16
	ltbFileNames.TextColor = Colors.Black
	ltbFileNames.ItemHeight = 40dip
	ltbFileNames.FastScrollEnabled = True

	ckbWithSetup.Checked = GC_SaveSetup
	
	GC_CurveI.Initialize
	
	FillCurveList
	FillFileLIst
	
	lblHelp.Text = "Select the curves to save in the list below and click on the Save button." & CRLF & "You can add a comment to the file." & CRLF & "You can save the curves with the setup or without the setup."
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Returns to Graph srceen", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub btnSave_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnSave, Action, X, Y, lblToolTip, "Save the selected curves.", "btnSave", "btnSaveDo", False)
End Sub

Sub btnSaveDo
	SaveCurves
End Sub

Sub ckbWithSetup_CheckedChange(Checked As Boolean)
	GC_SaveSetup = Checked
End Sub

Sub rbtFileType_CheckedChange(Checked As Boolean)
	Dim rbt As RadioButton
	
	rbt = Sender
	FileExtension = rbt.Tag
	
	FillFileLIst
End Sub

Sub ltbFiles_ItemClick(Position As Int, Item As String)
	edtFileName.Text = Item
End Sub

Sub FillCurveList
	Dim i As Int
	
	ltbCurves.Clear
	For i = 1 To Graph.CurveNb - 1
		ltbCurves.AddItem(i & ": " & Graph.CurveName(i))
	Next
End Sub

Sub FillFileLIst
	Dim lstFileNames As List
	Dim i As Int
	Dim FileName As String
	
	lstFileNames = File.ListFiles(Main.DefaultDir)
	lstFileNames.Sort(True)

	ltbFileNames.Clear
	For i = 0 To lstFileNames.Size - 1
		FileName = lstFileNames.Get(i)
		If FileName.EndsWith(FileExtension) Then
			ltbFileNames.AddItem(FileName)
		End If
	Next
End Sub

Sub SaveCurves
	Dim i, Answ As Int
	
	If ltbCurves.MultiSelectList.Size = 0 Then
		Msgbox("No curves selected !", "A T T E N T I O N")
		Return
	End If
	
	If edtFileName.Text = "" Then
		Msgbox("No file name !", "A T T E N T I O N")
		Return
	End If
	
	If File.Exists(Main.DefaultDir, CurveFile) Then
		Answ = Msgbox2("This file already exists, do you want to overwrite it ?", "A T T E N T I O N", "Yes", "", "No", Null)
		If Answ = DialogResponse.NEGATIVE Then
			Return
		End If
	End If
	
	For i = 0 To ltbCurves.MultiSelectList.Size - 1
		GC_CurveI.Add(ltbCurves.MultiSelectList.Get(i) + 1)
	Next
	
	GC_CurveNb = GC_CurveI.Size
	CurveFile = edtFileName.Text
	If CurveFile.SubString2(CurveFile.Length - 4, CurveFile.Length) <> FileExtension Then
		CurveFile = CurveFile&FileExtension
	End If
	
	If FileExtension = ".dsc" Then
		SaveCurvesDsc		' proprietary dsc format
	Else
		SaveCurvesCsv		' standard csv format
	End If
End Sub

Sub SaveCurvesDsc
	Dim i, j, k As Int
	
	tw.Initialize(File.OpenOutput(Main.DefaultDir, CurveFile, False))

	tw.WriteLine("DynSim100")			' version number
	
	tw.WriteLine(Graph.CurveSampleNb)
	tw.WriteLine(edtComment.Text)			' comment for curve file
	tw.WriteLine(GC_SaveSetup)		' flag save curves setup

	tw.WriteLine(GC_CurveNb)			' number of selected curves
	For i = 0 To GC_CurveNb - 1
		tw.WriteLine(GC_CurveI.Get(i))
		k = GC_CurveI.Get(i)
	Next

	For i = 0 To GC_CurveNb - 1
		k = GC_CurveI.Get(i)
		tw.WriteLine(Graph.CurveName(k))
		tw.WriteLine(Graph.CurveUnit(k))
		tw.WriteLine(Graph.CurveTime(k))
		tw.WriteLine(Graph.CurveDeg(k))
		tw.WriteLine(Graph.CurveSpd(k))
		tw.WriteLine(Graph.CurveSpdUnit(k))

		tw.WriteLine(Graph.CurveMax(k))
		tw.WriteLine(Graph.CurveMin(k))
		tw.WriteLine(Graph.CurveComm(k))
		tw.WriteLine(Graph.CurveCommText(k))
		tw.WriteLine(Graph.CurveCol(k))
		tw.WriteLine(Graph.CurveScMaxA(k))
		tw.WriteLine(Graph.CurveScMinA(k))
		tw.WriteLine(Graph.CurveScDA(k))
		tw.WriteLine(Graph.CurveScMaxM(k))
		tw.WriteLine(Graph.CurveScMinM(k))
		tw.WriteLine(Graph.CurveScDM(k))

		For j = 0 To Graph.CurveSampleNb
			tw.WriteLine(Graph.Curve(k,j))	' curve values
		Next 
	Next 
	
	If GC_SaveSetup = True Then
		SaveCurvesSetup
	End If

	tw.Close

End Sub

Sub SaveCurvesSetup
	Dim i, j As Int
	
	tw.WriteLine(Graph.J0C)
	tw.WriteLine(Graph.J1C)
	tw.WriteLine(Graph.J0z)
	tw.WriteLine(Graph.J1z)
	tw.WriteLine(Graph.CurveAbscissaType)
	tw.WriteLine(Main.TdTC)
	tw.WriteLine(Main.TdDC)

	tw.WriteLine(Graph.CurveDispNumbers)
	tw.WriteLine(Graph.CurveDispUnits)
	tw.WriteLine(Graph.CurveDispSpeed)
	tw.WriteLine(Graph.CurveDispComm)
	tw.WriteLine(Graph.CurveDispCommText)

	tw.WriteLine(Graph.CurveStep)
	tw.WriteLine(Graph.DrawBitmapFrame)
	tw.WriteLine(Graph.DrawBitmapColor)
	tw.WriteLine(Graph.DrawBitmapPreview)
	tw.WriteLine(Graph.DrawGridSizeI)

	For i = 0 To 3
		tw.WriteLine(Graph.ColCurve(i))
		tw.WriteLine(Graph.WidthCurve(i))
	Next
	
	tw.WriteLine(Graph.SupNb)
	tw.WriteLine(Graph.SupI)
	For i = 0 To Graph.SupNb - 1
		tw.WriteLine(Graph.SupIN(i))
		For j = 0 To Graph.SupIN(i) - 1
			tw.WriteLine(Graph.SupIJ(i, j))
		Next
	Next
End Sub

Sub SaveCurvesCsv
	Dim i, j As Int
	Dim tx As String
	
	tw.Initialize2(File.OpenOutput(Main.DefaultDir, CurveFile, False),"Window 1252")
	
	Select Graph.CurveAbscissaType
	Case 0
		tx = Main.Text(25)
	Case 1
		tx = Main.Text(26)
	Case 2
		tx = "[-]"
	End Select
	For i = 0 To GC_CurveNb - 1
		tx = tx & ";" & Graph.CurveName(GC_CurveI.Get(i))
	Next
	tw.WriteLine(tx)	
	
	Select Graph.CurveAbscissaType
	Case 0
		tx = "s"
	Case 1
		tx = "°"
	End Select
	For i = 0 To GC_CurveNb - 1
		tx = tx & ";" & Graph.CurveUnit(GC_CurveI.Get(i))
	Next
	tw.WriteLine(tx)	
	
	For i = 0 To Graph.CurveSampleNb
		tx = Graph.Curve(0, i)
		For j = 0 To GC_CurveNb - 1
			tx = tx & ";" & Graph.Curve(GC_CurveI.Get(j), i)
		Next
		tw.WriteLine(tx)	
	Next

	tw.Close
End Sub