﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim btnBack As Panel
	Dim lblTitle, lblToolTip As Label
	Dim cbbCurve1, cbbCurve2, cbbCurve3, cbbCurve4 As ComboBox
	Dim rbtAbscissaTime, rbtAbscissaDegree, rbtAbscissaIndex As RadioButton
	Dim cbxDispNumbers, cbxDispUnits, cbxDispSpeed, cbxSpeedUnit, cbxDispComment, cbxDispCommentText As CheckBox
	Dim edtJ0, edtJ1, edtDummy As EditText
	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("GraphSetup")
	
	FillCurveWidths
	Init

	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)
	IME1.Initialize("")
	
	Manage.txtDoNothing = Main.Text(234)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Returns to Graph srceen", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub Init
	cbbCurve1.SelectedIndex = Graph.WidthCurve(0) / GetDeviceLayoutValues.Scale - 1
	cbbCurve2.SelectedIndex = Graph.WidthCurve(1) / GetDeviceLayoutValues.Scale - 1
	cbbCurve3.SelectedIndex = Graph.WidthCurve(2) / GetDeviceLayoutValues.Scale - 1
	cbbCurve4.SelectedIndex = Graph.WidthCurve(3) / GetDeviceLayoutValues.Scale - 1
	
	Select Graph.CurveAbscissaType
	Case 0
		rbtAbscissaTime.Checked = True
	Case 1
		rbtAbscissaDegree.Checked = True
	Case 2
		rbtAbscissaIndex.Checked = True
	End Select

	cbxDispNumbers.Checked = Graph.CurveDispNumbers
	cbxDispUnits.Checked = Graph.CurveDispUnits
	cbxDispSpeed.Checked = Graph.CurveDispSpeed
	cbxSpeedUnit.Checked = Graph.CurveDispSpeedUnit
	cbxDispComment.Checked = Graph.CurveDispComm
	cbxDispCommentText.Checked = Graph.CurveDispCommText
	
	edtJ0.Text = Graph.J0C
	edtJ1.Text = Graph.J1C
End Sub

Sub FillCurveWidths
	Dim i As Int
	
	For i = 1 To 5
		cbbCurve1.Add(i)
		cbbCurve2.Add(i)
		cbbCurve3.Add(i)
		cbbCurve4.Add(i)
	Next
End Sub

Sub cbbCurve_ItemClick(Position As Int, Item As String)
	Dim cbb As ComboBox
	Dim Index, n As Int
	
	cbb = Sender
	Index = cbb.Tag
	n = Item
	Graph.WidthCurve(Index) = n * GetDeviceLayoutValues.Scale
End Sub

Sub rbtAbscissa_CheckedChange(Checked As Boolean)
	Dim rbt As RadioButton
	
	rbt = Sender
	Graph.CurveAbscissaType = rbt.Tag
End Sub

Sub cbxDispNumbers_CheckedChange(Checked As Boolean)
	Graph.CurveDispNumbers = Checked
End Sub

Sub cbxDispUnits_CheckedChange(Checked As Boolean)
	Graph.CurveDispUnits = Checked
End Sub

Sub cbxDispSpeed_CheckedChange(Checked As Boolean)
	Graph.CurveDispSpeed = Checked
End Sub

Sub cbxSpeedUnit_CheckedChange(Checked As Boolean)
	Graph.CurveDispSpeedUnit = Checked
End Sub

Sub cbxDispComment_CheckedChange(Checked As Boolean)
	Graph.CurveDispComm = Checked
End Sub

Sub cbxDispCommentText_CheckedChange(Checked As Boolean)
	Graph.CurveDispCommText = Checked
End Sub

Sub edtJ0_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ0, "edtJ0_ValueChanged", "Enter J0", "Int+")
	End If
End Sub

Sub edtJ0_ValueChanged(Value As Double)
	Graph.J0C = Value
End Sub

Sub edtJ1_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtJ1, "edtJ1_ValueChanged", "Enter J1", "Int+")
	End If
End Sub

Sub edtJ1_ValueChanged(Value As Double)
	Graph.J1C = Value
End Sub