﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim ltbCurves As ListBox
	Dim cbbSuperpos As ComboBox
	Dim btnOK, btnBack As Panel
	Dim lblTitle, lblTooltip As Label
	Dim lstSuperpos As List
	Dim cSupI As Int
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("GraphSuperpos")
	
	cbbSuperpos.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbSuperpos.ItemColor = Colors.RGB(255, 228, 181)
	cbbSuperpos.ItemTextColor = Colors.Black

	Calc.InitCurveListBox(ltbCurves)
	
	ltbCurves.ItemColor = Colors.RGB(255, 228, 181)
	ltbCurves.BackgroundColor = Colors.RGB(165, 42, 42)
	ltbCurves.TextSize = 16
	ltbCurves.TextColor = Colors.Black
	ltbCurves.ItemHeight = 40dip
	ltbCurves.MultiSelect = True
	ltbCurves.MaxNumberOfSelections = 4
	ltbCurves.FastScrollEnabled = True

	Calc.InitSuperposComboBox(cbbSuperpos)
	cSupI = Max(Graph.SupI, 0)
	cbbSuperpos.SelectedIndex = cSupI
	cbbSuperpos_ItemClick(cSupI, cbbSuperpos.SelectedItem)
	
	lstSuperpos.Initialize
	
	ToolTip("Select a superpostion in the top right list") 
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If Graph.SupIN(cSupI) = 0 Then
		Graph.SupI = -1
	Else
		Graph.SupI = cSupI
	End If
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub ltbCurves_ItemClick(Position As Int, Item As String)
'	btnOKDo
End Sub

Sub cbbSuperpos_ItemClick(Position As Int, Item As String)
	Dim i As Int
	
	ltbCurves.MultiSelectListClear
	
	cSupI = Position
	If Graph.SupIN(cSupI) > 0 Then
		Dim lst(Graph.SupIN(cSupI)) As Int
		For i = 0 To Graph.SupIN(cSupI) - 1
			lst(i) = (Graph.SupIJ(cSupI, i)) - 1
		Next
		If lst(0) > -1 Then
			ltbCurves.SetMultiSelection(lst)
		End If
	End If
	
	ToolTip("Select the curves in the list (max. 4 curves) and click on OK") 
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblTooltip, "Goes back to the Graph window", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub btnOK_Touch (Action As Int, X As Float, Y As Float)
	Manage.txtPermanentToolTip = "Select a superpostion in the top right list"
	Manage.ButtonClick(Me, btnOK, Action, X, Y, lblTooltip, "Sets the selected curves to superpose", "btnOK", "btnOKDo", True)
End Sub

Sub btnOKDo
	Dim i As Int
	Dim txt As String
	
	txt = (cSupI + 1) & " : "
	For i = 0 To ltbCurves.MultiSelectList.Size - 1
		Graph.SupIJ(cSupI, i) = ltbCurves.MultiSelectList.Get(i) + 1
		If i = 0 Then
			txt = txt & Graph.SupIJ(cSupI, i)
		Else
			txt = txt & " / " & Graph.SupIJ(cSupI, i)
		End If
	Next
	Graph.SupIN(cSupI) = ltbCurves.MultiSelectList.Size
	cbbSuperpos.SetItem(cSupI, txt)
End Sub

Sub ToolTip(txt As String)
	lblTooltip.Text = txt
	If txt = "" Then
		lblTooltip.Visible = False
	Else
		lblTooltip.Visible = True
	End If
End Sub