﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim lblTitle, lblFileList, lblToolTip, lblHelp As Label
	Dim ltbFileNames As ListBox
	Dim lstFileNames As List
	Dim FileName As String
	Dim btnDeleteFile, btnLoad, btnBack As Panel
	
	Dim SelectedFileIndex = -1 As Int
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("LoadModelFile")
	
	Main.flgNewFileLoaded = False
	
	ltbFileNames.ItemColor = Colors.RGB(255, 228, 181)
	ltbFileNames.BackgroundColor = Colors.RGB(165, 42, 42)
	ltbFileNames.MultiSelect = False
	ltbFileNames.TextSize = 16
	ltbFileNames.TextColor = Colors.Black
	ltbFileNames.ItemHeight = 40dip
	ltbFileNames.FastScrollEnabled = True

	UpdateLanguage
	
	FillListBox
	
	Main.flgNewFileLoaded = False
End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub FillListBox
	Dim i As Int
	Dim name As String
	
	ltbFileNames.MinSelections = 1
	lstFileNames = File.ListFiles(Main.DefaultDir)
	lstFileNames.Sort(True)
	ltbFileNames.Clear
	For i = 0 To lstFileNames.Size - 1
		name = lstFileNames.Get(i)
		If name.EndsWith(".mdl") Then
			ltbFileNames.AddItem(lstFileNames.Get(i))
		End If
	Next

	If ltbFileNames.Size > 0 Then
		FileName = ltbFileNames.GetItem(0)
		ltbFileNames_ItemClick(0, FileName)
		ltbFileNames.SelectedIndex = 0
	Else
		FileName = ""
	End If
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Returns to Graph srceen", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub btnLoad_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnLoad, Action, X, Y, lblToolTip, "Loads the selected model file.", "btnLoad", "btnLoadDo", False)
End Sub

Sub btnLoadDo
	If FileName <> "" Then
		Main.flgNewFileLoaded = True
		Main.ModelFile = FileName

		Activity.Finish
	Else
		Msgbox("No file selected", "A T T E N T I O N")
	End If
End Sub

Sub btnDeleteFile_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnDeleteFile, Action, X, Y, lblToolTip, "Deletes the selected file.", "btnDelete", "btnDeleteFileDo", False)
End Sub

Sub btnDeleteFileDo
	Dim Answ As Int
	
	Answ = Msgbox2("Do you really want to delete " & CRLF & FileName & " ?", "A T T E N T I O N", "Yes", "", "No", Null)
	
	If Answ = DialogResponse.POSITIVE Then
		File.Delete(Main.DefaultDir, FileName)
		ltbFileNames.RemoveAt(SelectedFileIndex)
'		FillListBox
		FileName = ""
		SelectedFileIndex = -1
	End If
End Sub

Sub ltbFileNames_ItemClick(Position As Int, Item As String)
	FileName = Item
	SelectedFileIndex = Position
End Sub

Sub UpdateLanguage
	lblTitle.Text = "Load a model file"
	lblFileList.Text = "List of model files"
	Dim txt As String
	txt = "Select the file you want to load in the list below" 
	txt = txt & CRLF & "- Click on the Load button to load the file"
	txt = txt & CRLF & "- Click on the Delete button to delete the file"
	lblHelp.Text = txt
End Sub
