﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim lblTitle, lblFileList, lblToolTip, lblHelp As Label
	Dim edtFileName As EditText
	Dim ltbFileNames As ListBox
	Dim lstFileNames As List
	Dim FileName As String
	Dim btnDeleteFile, btnSave, btnBack As Panel
	Dim Phone1 As Phone
	
	Dim SelectedFileIndex = -1 As Int
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("SaveModelFile")

	ltbFileNames.ItemColor = Colors.RGB(255, 228, 181)
	ltbFileNames.BackgroundColor = Colors.RGB(165, 42, 42)
	ltbFileNames.MultiSelect = False
	ltbFileNames.TextSize = 16
	ltbFileNames.TextColor = Colors.Black
	ltbFileNames.ItemHeight = 40dip
	ltbFileNames.FastScrollEnabled = True

	FillListBox
	UpdateLanguage
	Main.flgNewFileSaved = False
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub FillListBox
	Dim i As Int
	Dim name As String
	
	ltbFileNames.MinSelections = 1
	lstFileNames = File.ListFiles(Main.DefaultDir)
	lstFileNames.Sort(True)
	ltbFileNames.Clear
	For i = 0 To lstFileNames.Size - 1
		name = lstFileNames.Get(i)
		If name.EndsWith(".mdl") Then
			ltbFileNames.AddItem(lstFileNames.Get(i))
		End If
	Next
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Returns to Graph srceen", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub btnSave_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnSave, Action, X, Y, lblToolTip, "Saves the current model data.", "btnSave", "btnSaveDo", False)
End Sub

Sub btnSaveDo
	Dim Answ As Int
	
	If edtFileName.Text = "" Then
		Msgbox("No file selected", "A T T E N T I O N")
	Else
		If Not(edtFileName.Text.EndsWith(".mdl")) Then
			edtFileName.Text = edtFileName.Text & ".mdl"
		End If
		If File.Exists(Main.DefaultDir, edtFileName.Text) Then
			Answ = Msgbox2("This file already esits, do you want to overwrite it ?", "A T T E N T I O N", "Yes", "", "No", Null)
			If Answ = DialogResponse.NEGATIVE Then
				Return
			End If
		End If

		Main.ModelFile = edtFileName.Text
		Main.flgNewFileSaved = True
		Phone1.HideKeyboard(Activity)
		Activity.Finish
	End If
End Sub

Sub btnDeleteFile_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnDeleteFile, Action, X, Y, lblToolTip, "Deletes the selected file.", "btnDelete", "btnDeleteFileDo", False)
End Sub

Sub btnDeleteFileDo
	Dim Answ As Int
	
	Answ = Msgbox2("Do you really want to delete " & CRLF & FileName & " ?", "A T T E N T I O N", "Yes", "", "No", Null)
	
	If Answ = DialogResponse.POSITIVE Then
		File.Delete(Main.DefaultDir, FileName)
		ltbFileNames.RemoveAt(SelectedFileIndex)
'		FillListBox
		FileName = ""
		SelectedFileIndex = -1
	End If
End Sub

Sub ltbFileNames_ItemClick(Position As Int, Item As String)
	FileName = Item
	edtFileName.Text = Item
	SelectedFileIndex = Position
End Sub

Sub UpdateLanguage
	lblTitle.Text = "Save a model file"
	lblFileList.Text = "List of model files"
	Dim txt As String
	txt = "Enter the file name or select a file in the list below" 
	txt = txt & CRLF & "- Click on the Save button to save the current model data."
	txt = txt & CRLF & "- Click on the Delete button to delete the selected model file."
	lblHelp.Text = txt
End Sub

