﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals
	Public ScaleChange As Boolean
End Sub

Sub Globals
	Dim lblCurve() As Label
	Dim lblCurve0, lblCurve1, lblCurve2, lblCurve3, lblToolTip, lblHelp As Label
	Dim edtScaleMin(), edtScaleMax() As EditText
	Dim edtScaleMin0, edtScaleMin1, edtScaleMin2, edtScaleMin3 As EditText
	Dim edtScaleMax0, edtScaleMax1, edtScaleMax2, edtScaleMax3 As EditText
	Dim edtDummy As EditText
	Dim rbtSameScaleCurve() As RadioButton
	Dim rbtSameScaleCurve0, rbtSameScaleCurve1, rbtSameScaleCurve2, rbtSameScaleCurve3 As RadioButton
	Dim cbbCurves, cbbSuperpos As ComboBox
	Dim ckbSameScale As CheckBox
	Dim pnlSameScale, btnChangeScaleCalc, btnChangeScaleAuto, btnBack As Panel
	
	Dim GS_SupI, GS_CurveI As Int

	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("ScaleChange")
	
	lblCurve = Array As Label(lblCurve0, lblCurve1, lblCurve2, lblCurve3)
	edtScaleMin = Array As EditText(edtScaleMin0, edtScaleMin1, edtScaleMin2, edtScaleMin3)
	edtScaleMax = Array As EditText(edtScaleMax0, edtScaleMax1, edtScaleMax2, edtScaleMax3)
	rbtSameScaleCurve = Array As RadioButton(rbtSameScaleCurve0, rbtSameScaleCurve1, rbtSameScaleCurve2, rbtSameScaleCurve3)

	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)
	IME1.Initialize("")
	Manage.txtDoNothing = Main.Text(234)
	
	cbbCurves.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbCurves.ItemColor = Colors.RGB(255, 228, 181)
	cbbCurves.ItemTextColor = Colors.Black
	cbbCurves.FastScrollEnabled = True

	cbbSuperpos.BackgroundColor = Colors.RGB(165, 42, 42)
	cbbSuperpos.ItemColor = Colors.RGB(255, 228, 181)
	cbbSuperpos.ItemTextColor = Colors.Black
	
	UpdateLanguage
End Sub

Sub Activity_Resume
	GS_SupI = Graph.SupI
	GS_CurveI = Graph.CurveI

	Calc.InitCurveComboBox(cbbCurves)
	Calc.InitSuperposComboBox(cbbSuperpos)

	If Graph.SupI < 0 Then
		cbbCurves_ItemClick(Graph.CurveI - 1, cbbCurves.GetItem(Graph.CurveI - 1))
		cbbCurves.SelectedIndex = Graph.CurveI - 1
	Else
		cbbSuperpos_ItemClick(Graph.SupI, cbbSuperpos.GetItem(Graph.SupI))
		cbbSuperpos.SelectedIndex = Graph.SupI
	End If
	ScaleChange = True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	btnChangeScaleCalcDo
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub UpdateScreen
	Dim i, CurveIndex As Int
	
	If GS_SupI = -1 Then
		If Graph.CurveScMaxM(GS_CurveI) = 0 AND Graph.CurveScMinM(GS_CurveI) = 0 Then
			Calc.DrawCalcMinMax(GS_CurveI)
			Calc.DrawCalcScaleDiv(GS_CurveI, "Y")
		End If
		lblCurve(0).Text = GS_CurveI & ": " & Graph.CurveName(GS_CurveI)
		lblCurve(0).Visible = True
		edtScaleMin(0).Text = NumberFormat2(Graph.CurveScMinM(GS_CurveI), 1, 6, 0, False)
		edtScaleMin(0).Visible = True
		edtScaleMax(0).Text = NumberFormat2(Graph.CurveScMaxM(GS_CurveI), 1, 6, 0, False)
		edtScaleMax(0).Visible = True
		rbtSameScaleCurve(0).Visible = False
		
		For i = 1 To 3
			lblCurve(i).Visible = False
			edtScaleMin(i).Visible = False
			edtScaleMax(i).Visible = False
			rbtSameScaleCurve(i).Checked = False
			rbtSameScaleCurve(i).Visible = False
		Next
		
		ckbSameScale.Visible = False
		pnlSameScale.Visible = False
	Else
		For i = 0 To Graph.SupIN(GS_SupI) - 1
			CurveIndex = Graph.SupIJ(GS_SupI, i)
			If Graph.CurveScMaxM(CurveIndex) = 0 AND Graph.CurveScMinM(CurveIndex) = 0 Then
				Calc.DrawCalcMinMax(CurveIndex)
				Calc.DrawCalcScaleDiv(CurveIndex, "Y")
			End If
			lblCurve(i).Text = Calc.CurveListLine(CurveIndex, "", 1)
			lblCurve(i).Visible = True
			edtScaleMin(i).Text = NumberFormat2(Graph.CurveScMinM(CurveIndex), 0, 6, 0, False)
			edtScaleMin(i).Visible = True
			edtScaleMax(i).Text = NumberFormat2(Graph.CurveScMaxM(CurveIndex), 0, 6, 0, False)
			edtScaleMax(i).Visible = True
			rbtSameScaleCurve(i).Text = Calc.CurveListLine(CurveIndex, "", 1)
			rbtSameScaleCurve(i).Visible = True
			rbtSameScaleCurve(i).Checked = False
		Next
		
		For i = Graph.SupIN(GS_SupI) To 3
			lblCurve(i).Visible = False
			edtScaleMin(i).Visible = False
			edtScaleMax(i).Visible = False
			rbtSameScaleCurve(i).Visible = False
			rbtSameScaleCurve(i).Checked = False
		Next

		ckbSameScale.Visible = True
		pnlSameScale.Visible = ckbSameScale.Checked
		
		For i = 0 To 3
			rbtSameScaleCurve(i).Checked = False
		Next
	End If
End Sub

Sub cbbCurves_ItemClick (Position As Int, Value As Object)
	GS_SupI = -1
	GS_CurveI = Position + 1
	cbbSuperpos.SelectedIndex = -1
	UpdateScreen
End Sub

Sub cbbSuperpos_ItemClick (Position As Int, Value As Object)
	GS_SupI = Position
	cbbCurves.SelectedIndex = -1
	UpdateScreen
End Sub

Sub ckbSameScale_CheckedChange(Checked As Boolean)
	pnlSameScale.Visible = Checked
End Sub

Sub rbtSameScaleCurve_CheckedChange(Checked As Boolean)
	Dim rbt As RadioButton
	Dim i, index As Int
	
	rbt = Sender
	index = rbt.Tag
	
	For i = 0 To Graph.SupIN(GS_SupI) - 1
		edtScaleMin(i).Text = edtScaleMin(index).Text
		edtScaleMax(i).Text = edtScaleMax(index).Text
		Graph.CurveScMinM(i) = NumberFormat2(Graph.CurveScMinM(index), 0, 6, 0, False)
		Graph.CurveScMaxM(i) = NumberFormat2(Graph.CurveScMaxM(index), 0, 6, 0, False)
		Graph.CurveScDM(i) = NumberFormat2(Graph.CurveScDM(index), 0, 6, 0, False)
	Next
End Sub

Sub btnChangeScaleCalc_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnChangeScaleCalc, Action, X, Y, lblToolTip, "Calculates the scales with the given values", "btnCalc", "btnChangeScaleCalcDo", False)
End Sub

Sub btnChangeScaleCalcDo
	Dim i, j, ic As Int
	
	If GS_SupI = -1 Then
		j = 0
	Else
		j = Graph.SupIN(GS_SupI) - 1
	End If
	
	For i = 0 To j
		If GS_SupI = -1 Then
			ic = GS_CurveI
		Else
			ic = Graph.SupIJ(GS_SupI,i)
		End If
		Graph.CurveScMinM(ic) = edtScaleMin(i).Text
		Graph.CurveScMaxM(ic) = edtScaleMax(i).Text
		Graph.CurveScDM(ic)=(Graph.CurveScMaxM(ic) - Graph.CurveScMinM(ic)) / 10
	Next
End Sub

Sub btnChangeScaleAuto_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnChangeScaleAuto, Action, X, Y, lblToolTip, "Calculates the automatic scales", "btnScaleAuto", "btnChangeScaleAutoDo", False)
End Sub

Sub btnChangeScaleAutoDo
	Dim i, n, k As Int
	
	If GS_SupI = -1 Then
		n = 0
		k = GS_CurveI
	Else
		n = Graph.SupIN(GS_SupI)
	End If

	For i = 0 To n - 1
		If GS_SupI >= 0 Then
			k = Graph.SupIJ(GS_SupI,i)
		End If
		Calc.DrawCalcMinMax(k)
		Calc.DrawCalcScaleDiv(k,"Y")
		edtScaleMin(i).Text = NumberFormat2(Graph.CurveScMinA(k), 0, 6, 0, False)
		edtScaleMax(i).Text = NumberFormat2(Graph.CurveScMaxA(k), 0, 6, 0, False)
	Next

	For i = 0 To 3
		rbtSameScaleCurve(i).Checked = False
	Next
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Goes back to the Graphics window", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub edtScaleMin_FocusChanged(HasFocus As Boolean)
	Dim edt As EditText
	
	edt = Sender
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edt, "edtScaleMin_ValueChanged", "Enter J0", "Dbl-")
	End If
End Sub

Sub edtScaleMin_ValueChanged(Value As Double)

End Sub

Sub edtScaleMax_FocusChanged(HasFocus As Boolean)
	Dim edt As EditText
	
	edt = Sender
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edt, "edtScaleMax_ValueChanged", "Enter J0", "Dbl-")
	End If
End Sub

Sub edtScaleMax_ValueChanged(Value As Double)

End Sub

Sub UpdateLanguage
	Dim txt As String
	txt = "You can select either a curve or a superposition in the lists." & CRLF
	txt = txt & "Change the scale values and click on [+/-] to validate." & CRLF
	txt = txt & "If you want to set all scales the same as one of the curves, check 'Same scale' and select the curve." & CRLF
	txt = txt & "Click on [A] to recalculate automatic scales."
	lblHelp.Text = txt
End Sub
