﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals
End Sub

Sub Globals
	Dim ltbCurves As ListBox
	Dim lblToolTip, lblCurvesToCopy, lblCopyCurveAt As Label
	Dim pnlCopyCurveAt, pnlCopyInterval, pnlCurvesToCopy As Panel
	Dim SelectMode = 0 As Int
	Dim btnOK, btnBack As Panel
	Dim lstCurvesToCopy As List
	Dim edtIntervall, edtDummy As EditText
	Dim NumKeyboard As NumericKeyboard
	Dim IME1 As IME
	Dim pnlColor0 = Colors.RGB(255, 228, 181) As Int
	Dim pnlColorSelected = Colors.RGB(255, 215, 0) As Int
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("selectcurvestocopyat")

	Calc.InitCurveListBox(ltbCurves)
	Code.SetPadding(lblCurvesToCopy)
	Code.SetPadding(lblCopyCurveAt)
	
	ltbCurves.MaxNumberOfSelections = 20
	ltbCurves.FastScrollEnabled = True
	ltbCurves.BackgroundColor = Colors.RGB(165, 42, 42)
	ltbCurves.ItemColor = Colors.RGB(255, 228, 181)
	ltbCurves.TextColor = Colors.Black
	
	lstCurvesToCopy.Initialize

	NumKeyboard.Initialize(Me, Activity, "", False, edtDummy)
	IME1.Initialize("")
	Manage.txtDoNothing = Main.Text(234)
End Sub

Sub Activity_Resume
	SelectMode = 0
	btnOKDo
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub btnOK_Touch (Action As Int, X As Float, Y As Float)
	Dim bdw As BitmapDrawable
	
	Select Action
	Case Activity.ACTION_DOWN
		bdw.Initialize(LoadBitmap(File.DirAssets, "btnOK" & "1.png"))
		btnOK.Background = bdw
'		ToolTip(ToolTipText)
	Case Activity.ACTION_MOVE
'		If X > 0 AND X < Main.ButtonSize AND Y > 0 AND Y < Main.ButtonSize Then
'			ToolTip(ToolTipText)
'		Else
'			ToolTip("Do nothing")
'		End If
	Case Activity.ACTION_UP
		If X > 0 AND X < Main.ButtonSize AND Y > 0 AND Y < Main.ButtonSize Then
			btnOKDo
		End If
		bdw.Initialize(LoadBitmap(File.DirAssets, "btnOK" & "0.png"))
		btnOK.Background = bdw
'		ToolTip("")
	End Select
End Sub

Sub btnOKDo
	Dim i, n As Int
	
	Select SelectMode
	Case 0
		lblToolTip.Text = "Select the curves to copy and click on 'OK'"
		ltbCurves.MultiSelectListClear
		ltbCurves.MultiSelect = True
		SelectMode = 1
		pnlCopyInterval.Color = pnlColor0
		pnlCurvesToCopy.Color = pnlColorSelected
		Dim txt = "" As String
		Dim lst As List
		lst.Initialize
		For i = 0 To Main.CC_I.Size - 1
			n = Main.CC_I.Get(i)
			If i = 0 Then
				txt = n
			Else
				txt = txt & " / " & n
			End If
			lst.Add(n - 1)
		Next
		ltbCurves.SetMultiSelectList(lst)
		lblCurvesToCopy.Text = txt
		lblCopyCurveAt.Text = Main.CC_DestI
	Case 1
		Dim lstCurvesToCopy As List
		lstCurvesToCopy.Initialize
		For i = 0 To ltbCurves.MultiSelectList.Size - 1
			lstCurvesToCopy.Add(ltbCurves.MultiSelectList.Get(i) + 1)
		Next
		pnlCurvesToCopy.Color = pnlColor0
		pnlCopyCurveAt.Color = pnlColorSelected
		lblToolTip.Text = "Select the curve where you want to copy the first curve and click on 'OK' to confirm"
		ltbCurves.MultiSelectListClear
		ltbCurves.MultiSelect = False
		Dim n As Int
		n = lblCopyCurveAt.Text
		ltbCurves.SelectedIndex = n - 1
		SelectMode = 2
	Case 2
		lblCopyCurveAt.Text = (ltbCurves.SelectedIndex + 1)
		lblToolTip.Text = "Enter the interval of the curves to copy, and click 'OK' to confirm"
		SelectMode = 3
		pnlCopyCurveAt.Color = pnlColor0
		pnlCopyInterval.Color = pnlColorSelected
	Case 3
		Main.CC_Copy = True
		Main.CC_DestI = lblCopyCurveAt.Text
		Main.CC_Interval = edtIntervall.Text
		Main.CC_Nb = lstCurvesToCopy.Size
		Main.CC_I = lstCurvesToCopy
		Activity.Finish
	End Select
End Sub

Sub pnlCurvesToCopy_Click
	SelectMode = 0
	pnlCopyCurveAt.Color = pnlColor0
	pnlCopyInterval.Color = pnlColor0
	btnOKDo
End Sub

Sub pnlCopyCurveAt_Click
	SelectMode = 1
	lblCurvesToCopy.Color = pnlColor0
	pnlCopyInterval.Color = pnlColor0
	btnOKDo
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Goes back to the Graphics window", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

Sub edtIntervall_FocusChanged(HasFocus As Boolean)
	If HasFocus = True Then
		IME1.HideKeyboard
		NumKeyboard.Show(-1, -1, edtIntervall, "edtIntervall_ValueChanged", "Enter curve to copy interval", "Int+")
	End If
End Sub

Sub edtIntervall_ValueChanged(Value As Double)
	Main.CC_Interval = Value
End Sub

Sub ltbCurves_ItemClick(Position As Int, Item As String)
	Dim txt As String
	Dim i As Int

	Select SelectMode
	Case 1
		For i = 0 To ltbCurves.MultiSelectList.Size - 1
			If i = 0 Then
				txt = (ltbCurves.MultiSelectList.Get(i) + 1)
			Else
				txt = txt & " / " & (ltbCurves.MultiSelectList.Get(i) + 1)
			End If
		Next
		lblCurvesToCopy.Text = txt
	Case 2
		lblCopyCurveAt.Text = Position + 1
	End Select
End Sub
