﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True

	#IgnoreWarnings: 12
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim rbtEnglish, rbtFrench, rbtGerman, rbtSpanish, rbtItalian, rbtPortuguese, rbtOther As RadioButton
	Dim lblTitle, lblLanguage, lblToolTip As Label
	Dim ckbPromptExit, ckbLoadLastFile, ckbCalculateResult As CheckBox
	Dim btnBack As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("setup")
	InitActivity
	UpdateLanguage
End Sub

Sub Activity_Resume
	Code.SaveInit
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		Activity.Finish
	End If
End Sub

Sub InitActivity
	Dim LDir, LFile As String
	
	LDir = Main.DefaultDir
	LFile = "DynSim_en.txt"
	If File.Exists(LDir, LFile) = True Then
		rbtEnglish.Enabled = True
		rbtEnglish.TextColor = Colors.RGB(162, 42, 42)
	Else
		rbtEnglish.Enabled = False
		rbtEnglish.TextColor = Colors.Gray
	End If
	
	LFile = "DynSim_fr.txt"
	If File.Exists(LDir, LFile) = True Then
		rbtFrench.Enabled = True
		rbtFrench.TextColor = Colors.RGB(162, 42, 42)
	Else
		rbtFrench.Enabled = False
		rbtFrench.TextColor = Colors.Gray
	End If

	LFile = "DynSim_de.txt"
	If File.Exists(LDir, LFile) = True Then
		rbtGerman.Enabled = True
		rbtGerman.TextColor = Colors.RGB(162, 42, 42)
	Else
		rbtGerman.Enabled = False
		rbtGerman.TextColor = Colors.Gray
	End If

	LFile = "DynSim_es.txt"
	If File.Exists(LDir, LFile) = True Then
		rbtSpanish.Enabled = True
		rbtSpanish.TextColor = Colors.RGB(162, 42, 42)
	Else
		rbtSpanish.Enabled = False
		rbtSpanish.TextColor = Colors.Gray
	End If

	LFile = "DynSim_it.txt"
	If File.Exists(LDir, LFile) = True Then
		rbtItalian.Enabled = True
		rbtItalian.TextColor = Colors.RGB(162, 42, 42)
	Else
		rbtItalian.Enabled = False
		rbtItalian.TextColor = Colors.Gray
	End If
	
	LFile = "DynSim_pt.txt"
	If File.Exists(LDir, LFile) = True Then
		rbtPortuguese.Enabled = True
		rbtPortuguese.TextColor = Colors.RGB(162, 42, 42)
	Else
		rbtPortuguese.Enabled = False
		rbtPortuguese.TextColor = Colors.Gray
	End If

	LFile = "DynSim_ot.txt"
	If File.Exists(LDir, LFile) = True Then
		rbtOther.Enabled = True
		rbtOther.TextColor = Colors.RGB(162, 42, 42)
	Else
		rbtOther.Enabled = False
		rbtOther.TextColor = Colors.Gray
	End If
	
	ckbPromptExit.Checked = Main.flgPromptExit
	ckbLoadLastFile.Checked = Main.flgLoadLastFile
	ckbCalculateResult.Checked = Main.flgCalculateResult
	
	Select Main.Language_I
	Case Main.cEnglish
		rbtEnglish.Checked = True
	Case Main.cFrench
		rbtFrench.Checked = True
	Case Main.cGerman
		rbtGerman.Checked = True
	Case Main.cSpanish
		rbtSpanish.Checked = True
	Case Main.cItalian
		rbtItalian.Checked = True
	Case Main.cPortuguese
		rbtPortuguese.Checked = True
	Case Main.cOther
		rbtOther.Checked = True
	End Select	
End Sub

Sub rbtLanguage_CheckedChange(Checked As Boolean)
	Dim rbt As RadioButton
	
	rbt = Sender
	Main.Language_I = rbt.Tag
	Code.LoadLanguageText
	UpdateLanguage
End Sub

Sub UpdateLanguage
	lblTitle.Text = Main.Text(2)
	lblLanguage.Text = Main.Text(0)
	ckbPromptExit.Text = Main.Text(6)
	ckbLoadLastFile.Text = Main.Text(7)
	ckbCalculateResult.Text = Main.Text(235)
End Sub

Sub ckbCalculateResult_CheckedChange(Checked As Boolean)
	Main.flgCalculateResult = Checked
End Sub

Sub ckbPromptExit_CheckedChange(Checked As Boolean)
	Main.flgPromptExit = Checked
End Sub

Sub ckbLoadLastFile_CheckedChange(Checked As Boolean)
	Main.flgLoadLastFile = Checked
End Sub

Sub btnBack_Touch (Action As Int, X As Float, Y As Float)
	Manage.ButtonClick(Me, btnBack, Action, X, Y, lblToolTip, "Returns to main srceen", "btnBack", "btnBackDo", False)
End Sub

Sub btnBackDo
	Activity.Finish
End Sub

